package coco.filehandling;

import javax.swing.JFileChooser;
import java.io.*;

import coco.utils.*;
import coco.config.GlobalConfig;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public class FileService {

    public FileService() {
    }

    public static File doFileDialog(BaseFileFilter filter){

	String basePath = GlobalConfig.getInstance().getProperty(GlobalConfig.OPTION_LASTDIR);
	if(basePath == null)
	    basePath = "";
	JFileChooser fileDlg = new JFileChooser(basePath);
	fileDlg.setFileFilter(filter);

	// no file selected.
	if( JFileChooser.APPROVE_OPTION!=fileDlg.showOpenDialog(null)){
	    System.out.println("No file selected");
	    return null;
	}
	File dir = fileDlg.getCurrentDirectory();
	GlobalConfig.getInstance().setProperty(GlobalConfig.OPTION_LASTDIR, dir.getAbsolutePath());
	return fileDlg.getSelectedFile();
    }

    public static File[] doFileDialogMulti(BaseFileFilter filter){

	String basePath = GlobalConfig.getInstance().getProperty(GlobalConfig.OPTION_LASTDIR);
	if(basePath == null)
	    basePath = "";

	JFileChooser fileDlg = new JFileChooser(basePath);
	fileDlg.setFileFilter(filter);
	// multi-Selection
	fileDlg.setMultiSelectionEnabled(true);

	// no file selected.
	if( JFileChooser.APPROVE_OPTION!=fileDlg.showOpenDialog(null)){
	    System.out.println("No file selected");
	    return null;
	}

	File dir = fileDlg.getCurrentDirectory();
	GlobalConfig.getInstance().setProperty(GlobalConfig.OPTION_LASTDIR, dir.getAbsolutePath());

	return fileDlg.getSelectedFiles();
    }

    public static File doDirectoryDialog() {

	String basePath = GlobalConfig.getInstance().getProperty(GlobalConfig.OPTION_LASTDIR);

	if (basePath == null) basePath = "";

	JFileChooser fileDlg = new JFileChooser(basePath);
	//fileDlg.setFileFilter(filter);

	// Directories only
	fileDlg.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

	// no file selected.
	if( JFileChooser.APPROVE_OPTION!=fileDlg.showOpenDialog(null)){
	    System.out.println("No file selected");
	    return null;
	}

	File dir = fileDlg.getCurrentDirectory();
	GlobalConfig.getInstance().setProperty(GlobalConfig.OPTION_LASTDIR, dir.getAbsolutePath());

	return fileDlg.getSelectedFile();
    }

    public static void copyFile(File fromFile, File toFile) {
	byte[] buf = new byte[1024];

	try {
	    if (!fromFile.equals(toFile)) {
		FileInputStream in = new FileInputStream(fromFile);
		FileOutputStream out = new FileOutputStream(toFile);

		int len;
		
		while ((len = in.read(buf)) > -1) {
		    out.write(buf, 0, len);
		}

		out.close();
		in.close();
	    }

	} catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
}
