package coco.gui;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.filechooser.*;
import javax.swing.event.*;

import coco.filehandling.*;
import coco.model.*;
import coco.model.nodes.*;
import coco.fuzzyparser.*;
import coco.utils.*;
import coco.config.*;
import coco.project.CoCoProject;
import coco.tools.*;

import coco.gui.editor.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @authorproject
 * @version 1.0
 */

public class CoCoFrame extends JFrame {
    JPanel contentPane;
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenu jMenuHelp = new JMenu();
    JMenuItem jMenuHelpAbout = new JMenuItem();
    JToolBar jToolBar = new JToolBar();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image3;
    JLabel statusBar = new JLabel();
    JMenuItem jMenuQuit = new JMenuItem();
    JSplitPane jSplitPane2 = new JSplitPane();
    JEditorPane jEditorPane1 = new JEditorPane();
    JScrollPane jScrollPane3 = new JScrollPane();
    JMenu jMenuTools = new JMenu();

    JMenuItem jMenuItemCheck = new JMenuItem();

    // new ...

    JMenuItem jMenuLoadRules = new JMenuItem();
    CombinedTextOutputPane outputPane = new CombinedTextOutputPane();
    CoCoJTree jTreeOpenFiles = new CoCoJTree();
    JSplitPane jSplitPane1 = new JSplitPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JScrollPane jDetailPane = new JScrollPane();
    JMenuItem jMenuItemOptions = new JMenuItem();
    JMenu jMenuRecentFilesSub = new JMenu();
    JMenu jMenuRecentProjects = new JMenu();
    JMenu jMenuRecentFiles = new JMenu();
    JMenu jMenuProject = new JMenu();
    JMenuItem jMenuItemNewProject = new JMenuItem();
    JMenuItem jMenuItemCloseProject = new JMenuItem();
    JMenuItem jMenuItemOpenProject = new JMenuItem();
    JMenuItem jMenuItem4 = new JMenuItem();
    JMenuItem jMenuItemBrowseRepository = new JMenuItem();
    JMenuItem jMenuItemSaveProjectAs = new JMenuItem();
    JMenuItem jMenuItemSaveProject = new JMenuItem();
    boolean arrived = false;
    BorderLayout borderLayout1 = new BorderLayout();

    MultiEdit multiEdit = new MultiEdit();

    Controller controller = new Controller(jTreeOpenFiles, multiEdit);

    TreePopupMenu treePopup = new TreePopupMenu(controller);
  //JMenuItem jMenuItem1 = new JMenuItem();
  JMenu jMenu1 = new JMenu();
  JMenu jMenu2 = new JMenu();
  JMenuItem jMenuItemNewComponent = new JMenuItem();
  JMenuItem jMenuItemNewAbstractComponent = new JMenuItem();
  JMenuItem jMenuItemNewPropertySet = new JMenuItem();
  JMenuItem jMenuItemNewDataType = new JMenuItem();

  JMenuItem jMenuItemAddComponent = new JMenuItem();
  JMenuItem jMenuItemAddAbstractComponent = new JMenuItem();
  JMenuItem jMenuItemAddPropertySet = new JMenuItem();
  JMenuItem jMenuItemAddDataType = new JMenuItem();

    // tools
    Vector tools = new Vector();

    // ------------------------------------------ Constructors

    /**
     * Constructor
     */
    public CoCoFrame() {
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	try {
	    jbInit();
	} catch(Exception e) {
	    e.printStackTrace();
	}
    // take a look, if there is a project file in global config
    String lastProject = GlobalConfig.getInstance().getProperty(GlobalConfig.OPTION_PROJECT_LAST);
    if ((lastProject != null) && (!lastProject.equals(""))) {
      File f = new File(lastProject);
      if (f.exists()) {
        CoCoProject prj = new CoCoProject(f);
        Controller.getInstance().setProject(prj);
      }
    } else {
      //this.openProjectFile(null);
    }
    }

    // ------------------------------------------ Methods

    /**
     * Open a project form a project file.
     */
    void openProjectFileByName(String fname) {
     	File f = new File(fname);
	if(f.exists()){
	    openProjectFile(f);
	} else {
	    System.err.println("File " + fname + " not found.");
	}
    }

    private void saveProject() {
                if(!controller.projectCanSave()){
                CoCoProjectFileFilter filter = new CoCoProjectFileFilter();
                File f = FileService.doFileDialog(filter);
                if (f != null){
                  if (filter.getExtension(f) == null)
                    f = new File(f.getAbsolutePath() + ".coco");
                    controller.saveProjectAs(f);
                    RecentFilesManager.getInstance().addRecentProject(f.getAbsolutePath());
                  }
                  else return;
                } else
                  controller.saveProject();
    }

    private void saveProjectAs() {
      CoCoProjectFileFilter filter = new CoCoProjectFileFilter();
      File f = FileService.doFileDialog(filter);
      if (f != null){
        if (filter.getExtension(f) == null) {
          f = new File(f.getAbsolutePath() + ".coco");
          controller.saveProjectAs(f);
          RecentFilesManager.getInstance().addRecentProject(f.getAbsolutePath());
        }
      } else {System.out.println("Error: No File selected.");}
    }

    /**
     * Check, if the current project can be abandoned. If no, ask for
     * saving. If no preset file is there, open the file dialog to
     * choose the desired projekt file.
     *
     * returns false only, if CANCLE is selected
     */
    private boolean checkForUnsavedChanges() {
        if(controller.projectHasChanged()){
          MessageBox msg =
            new MessageBox("Question",
              "The project has unsaved changes. Do you want to save the changed files?",
              MessageBox.STYLE_YESNOCANCEL);
            msg.show();
            switch(msg.answer){
              case MessageBox.ANSWER_YES:
                // save the project
                saveProject();
                return true;
              case MessageBox.ANSWER_CANCEL:
                return false;
            }
        }
        return true;
    }

    /**
     * Open a the project file param. If no file is passed, open a
     * file dialog.
     */
    void openProjectFile(File param) {
	File file = param;
        // if now file is given, open file dialog
	if (file == null) {
	    file = FileService.doFileDialog(new CoCoProjectFileFilter());
	    if (file == null) {
		System.out.println("Project file is null");
                return;
	    }
	}
        CoCoProject prj = new CoCoProject(file);
        // add loaded project file to recent file list
	RecentFilesManager.getInstance().addRecentProject(file.getAbsolutePath());
        // set project in the controller
	controller.setProject(prj);
    }

    /**
     * Open an Entity File
     */
    void openComponentFileByName(String fname){
	File f = new File(fname);
	if(f.exists()){
	    openComponentFile(f, null);
	} else
	    System.err.println("File " + fname + " not found.");
    }

    // 
    void openComponentFile(File param, String filter){
	File f = param;

	File[] files = null;
	if (f == null) {
	    files = FileService.doFileDialogMulti(new CoCoFileFilter(filter));

	    if (files != null) {
		System.out.println("#files: " + files.length);
		for (int i = 0; i < files.length; i++) {
		    System.out.println(files[i]);
		    openComponentFile(files[i], filter);
		}
	    } else {
		System.out.println("Files are null");
	    }
	    return;
	}

        // file != null here !
	RecentFilesManager.getInstance().addRecentFile(f.getAbsolutePath());
        if (f.getName().endsWith(".cm")) {
          controller.addComponentFileToProject(f);
        }
        if (f.getName().endsWith(".acm")) {
          controller.addAbstractComponentFileToProject(f);
        }
        if (f.getName().endsWith(".prop")) {
          controller.addPropertySetFileToProject(f);
        }
        if (f.getName().endsWith(".type")) {
          controller.addDataTypeFileToProject(f);
        }


    }

    /**
     *
     */
    private void loadRecentFiles(){
	RecentFilesManager recentFilesManager = RecentFilesManager.getInstance();
	Vector recentFiles = recentFilesManager.getRecentFiles();
	Vector recentProjects = recentFilesManager.getRecentProjects();
	jMenuRecentFiles.removeAll();
	int currentEntries = recentFiles.size();

	String file;
	for(int idx = 0; idx < currentEntries; idx++){
	    file = (String)recentFiles.get(idx);
	    Assert.require(file);
	    JMenuItem item = new JMenuItem("[" + Integer.toString(idx+1) + "] " + file);
	    item.setActionCommand(file);
	    jMenuRecentFiles.add(item);
	    item.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			openComponentFileByName(e.getActionCommand());
		    }
		});
	}

	jMenuRecentProjects.removeAll();

	currentEntries = recentProjects.size();

	for(int idx = 0; idx < currentEntries; idx++){
	    file = (String)recentProjects.get(idx);
	    Assert.require(file);
	    JMenuItem item = new JMenuItem("[" + Integer.toString(idx+1) + "] " + file);
	    item.setActionCommand(file);
	    jMenuRecentProjects.add(item);
	    item.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			openProjectFileByName(e.getActionCommand());
		    }
		});
	}
    }

    private void shutdown(){
	try{
	    GlobalConfig.getInstance().writeConfig();
	}catch(java.io.IOException ex){
	    System.out.println("Could not save configuration file.");
	    ex.printStackTrace();
	}

	try{
	    RecentFilesManager.getInstance().writeHistory();
	}catch(java.io.IOException ex2){
	    System.out.println("Could not save recent files list.");
	    ex2.printStackTrace();
	}
    }

    public void browseRepository() {
    /*	RepositoryFrame f = new RepositoryFrame(controller);
	f.readRepository();
	f.setVisible(true);*/
    }


    // ------------------------------------------ Event Triggered Methods

    public void jMenuItemAddComponent_actionPerformed(ActionEvent e) {
      openComponentFile(null,"cm");
    }

    public void jMenuItemAddAbstractComponent_actionPerformed(ActionEvent e) {
      openComponentFile(null,"acm");
    }

    public void jMenuItemAddPropertySet_actionPerformed(ActionEvent e) {
      openComponentFile(null,"prop");
    }

    public void jMenuItemAddDataType_actionPerformed(ActionEvent e) {
      openComponentFile(null,"type");
    }

    /**
     * This is the general tool action listener.
     * It invokes the tool associated with the menu entry.
     */
    public void tool_actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();

	if (cmd.startsWith("TOOL_")) {
	    int index = -1;
	    try {
		index = Integer.parseInt(cmd.substring(5));
	    } catch (Exception ex) {
		ex.printStackTrace();
	    }

	    if (index < tools.size()) {
		CoCoTool tool = (CoCoTool)tools.elementAt(index);
		tool.execute(controller.getProject());
	    }
	}
    }


    /**
     * Aktion Hilfe | Info durchgefhrt
     */
    public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
	CoCoFrame_Infodialog dlg = new CoCoFrame_Infodialog(this);
	Dimension dlgSize = dlg.getPreferredSize();
	Dimension frmSize = getSize();
	Point loc = getLocation();
	dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
	dlg.setModal(true);
	dlg.show();
    }

    /**
     * berschrieben, so dass eine Beendigung beim Schlieen des Fensters
     * mglich ist.
     */
    protected void processWindowEvent(WindowEvent e) {
	super.processWindowEvent(e);
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    jMenuQuit_actionPerformed(null);
	}
    }

    void jMenuQuit_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuQuit_actionPerformed");
        if (checkForUnsavedChanges()) {
          shutdown();
          System.exit(0);
        }
    }

    /**
     * invoked when the selected value in the tree view changes
     */
    void jTreeOpenFiles_valueChanged(TreeSelectionEvent e) {
        //System.out.println("E: jTreeOpenFiles_valueChanged");
	CoCoTreeNode node = (CoCoTreeNode)
          jTreeOpenFiles.getLastSelectedPathComponent();
        if((node != null) && (node instanceof CoCoTreeNode)){
          controller.showComponent(node);
        }
    }

    /**
     * Selection of node in the tree.
     */
    void jTreeOpenFiles_mouseClicked(MouseEvent e) {
      //System.out.println("E: jTreeOpenFiles_mouseClicked");
      TreePath p = jTreeOpenFiles.getPathForLocation(e.getX(), e.getY());

      if(p != null){
        jTreeOpenFiles.setSelectionPath(p);
        CoCoTreeNode node = (CoCoTreeNode) p.getLastPathComponent();

        if(e.getModifiers() == e.META_MASK){
          // rechte maustaste
          treePopup.prepare(node);
          treePopup.show(this.jTreeOpenFiles, e.getX(), e.getY());
        }
        // linke maustaste
        if((node != null) && (node instanceof CoCoTreeNode)){

          if(node instanceof ErrorTreeNode)
            System.out.println(((ErrorTreeNode)node).getDescription());
          controller.showComponent(node);
        }
      }
    }

    void jMenuLoadRules_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuLoadRules_actionPerformed");
	// !!! openRuleFile(null);
    }

    void jMenuItemCheck_actionPerformed(ActionEvent e) {
        System.out.println("\nTrying to parse all entities...");
	controller.check();
    }

    void jMenuItemOptions_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemOptions_actionPerformed");
	OptionDialog dlg = new OptionDialog();
	Dimension dlgSize = dlg.getPreferredSize();
	Dimension frmSize = getSize();
	Point loc = getLocation();
	dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
	dlg.setModal(false);
	dlg.show();
    }

    void jMenuItemNewProject_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemNewProject_actionPerformed");
        if (checkForUnsavedChanges()) {
          controller.closeProject();
       	  controller.setProject(new CoCoProject());
        }
    }

    void jMenuRecentFilesSub_menuSelected(MenuEvent e) {
        //System.out.println("E: jMenuRecentFilesSub_menuSelected");
	loadRecentFiles();
    }

    void jMenuItemSaveProjectAs_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemSaveProjectAs_actionPerformed");
        saveProjectAs();
    }


    void jMenuItemOpenProject_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItem1_actionPerformed");
	openProjectFile(null);
    }

    void jMenuItemCloseProject_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemCloseProject_actionPerformed");
        if (checkForUnsavedChanges()) {
          controller.closeProject();
        }
    }

    void jMenuItemBrowseRepository_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemBrowseRepository_actionPerformed");
	//browseRepository();
    }

    void jMenuItemSaveProject_actionPerformed(ActionEvent e) {
        //System.out.println("E: jMenuItemSaveProject_actionPerformed");
        saveProject();
   }

   void jMenueItemNewComponent_actionPerformed(ActionEvent e) {
    // Ask for name here
    //String name = NameDialog.showNameDialog(null, "Choose name");

    String name = NameDialog.showNameDialog(this, "Choose Name for Component", "Name", "Filename",
      new NameDialog.DialogHelperAdapter() {
        public String complete(String name) {return(name+".cm");}
      });

    if (name != null){
      this.controller.addNewComponentToProject(name);
    }
   }

    // ------------------------------------------ Initialisation

    /**
     * Initialize the CoCoFrame.
     */
    private void jbInit() throws Exception  {
	image1 = new ImageIcon(coco.gui.CoCoFrame.class.getResource("openFile.gif"));
	image2 = new ImageIcon(coco.gui.CoCoFrame.class.getResource("closeFile.gif"));
	image3 = new ImageIcon(coco.gui.CoCoFrame.class.getResource("help.gif"));

	setIconImage(Toolkit.getDefaultToolkit().createImage(CoCoFrame.class.getResource("pecos.gif")));

	contentPane = (JPanel) this.getContentPane();
	contentPane.setLayout(borderLayout1);
	this.setSize(new Dimension(800, 400));
	this.setTitle("PECOS Composition Environment");
	statusBar.setText(" ");
	jMenuFile.setActionCommand("File");
	jMenuFile.setText("File");
	jMenuHelp.setText("Help");
	jMenuHelpAbout.setText("About");
	jMenuHelpAbout.addActionListener(new ActionListener()  {
		public void actionPerformed(ActionEvent e) {
		    jMenuHelpAbout_actionPerformed(e);
		}
	    });
	jButton1.setIcon(image1);
	jButton1.setToolTipText("Datei ffnen");
	jButton2.setIcon(image2);
	jButton2.setToolTipText("Datei schlieen");
	jButton3.setIcon(image3);
	jButton3.setToolTipText("Hilfe");
	jMenuQuit.setText("Exit");
	jMenuQuit.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuQuit_actionPerformed(e);
		}
	    });

	jEditorPane1.setEditable(false);
	jSplitPane2.setOrientation(JSplitPane.VERTICAL_SPLIT);
	jMenuTools.setText("Tools");

        // new ...


	jMenuLoadRules.setText("Add rules to project...");
	jMenuLoadRules.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuLoadRules_actionPerformed(e);
		}
	    });

	jTreeOpenFiles.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
		public void valueChanged(TreeSelectionEvent e) {
		    jTreeOpenFiles_valueChanged(e);
		}
	    });
	jTreeOpenFiles.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    jTreeOpenFiles_mouseClicked(e);
		}
	    });

	jSplitPane1.setOneTouchExpandable(true);
        //jSplitPane1.setPreferredSize(new Dimension(500,400));
	//contentPane.setPreferredSize(new Dimension(500, 400));
	jMenuItemOptions.setText("Options...");
	jMenuItemOptions.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemOptions_actionPerformed(e);
		}
	    });
	jMenuRecentFilesSub.setText("Recent files");
	jMenuRecentFilesSub.addMenuListener(new javax.swing.event.MenuListener() {
		public void menuSelected(MenuEvent e) {
		    jMenuRecentFilesSub_menuSelected(e);
		}
		public void menuDeselected(MenuEvent e) {
		}
		public void menuCanceled(MenuEvent e) {
		}
	    });
	jMenuRecentProjects.setText("Projects");
	jMenuRecentFiles.setText("Files");
	jMenuProject.setText("Project");
	jMenuItemNewProject.setText("New Project...");
    jMenuItemNewProject.setAccelerator(javax.swing.KeyStroke.getKeyStroke(78, java.awt.event.KeyEvent.CTRL_MASK | java.awt.event.KeyEvent.SHIFT_MASK, false));
	jMenuItemNewProject.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemNewProject_actionPerformed(e);
		}
	    });

	jMenuItemCloseProject.setText("Close Project");
	jMenuItemCloseProject.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemCloseProject_actionPerformed(e);
		}
	    });

	jMenuItemOpenProject.setText("Open Project...");
    jMenuItemOpenProject.setAccelerator(javax.swing.KeyStroke.getKeyStroke(79, java.awt.event.KeyEvent.CTRL_MASK | java.awt.event.KeyEvent.SHIFT_MASK, false));
	jMenuItemOpenProject.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemOpenProject_actionPerformed(e);
		}
	    });

	jMenuItem4.setText("Project settings");
	jMenuItemSaveProjectAs.setActionCommand("Save Project as...");
        jMenuItemSaveProjectAs.setText("Save Project as...");
	jMenuItemSaveProjectAs.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemSaveProjectAs_actionPerformed(e);
		}
	    });

	jMenuItemBrowseRepository.setText("Browse Repository...");
	jMenuItemBrowseRepository.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jMenuItemBrowseRepository_actionPerformed(e);
		}
	    });
	//

	jMenuItemSaveProject.setText("Save project");
    jMenuItemSaveProject.setAccelerator(javax.swing.KeyStroke.getKeyStroke(83, java.awt.event.KeyEvent.CTRL_MASK | java.awt.event.KeyEvent.SHIFT_MASK, false));
    jMenuItemSaveProject.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemSaveProject_actionPerformed(e);
      }
    });


//    jMenuItem1.setText("Add File to project...");

    jMenuItemNewComponent.setText("New component");
    jMenuItemNewComponent.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemNewComponent_actionPerformed(e);
      }
    });
    jMenuItemNewAbstractComponent.setText("New abstract component");
    jMenuItemNewAbstractComponent.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemNewAbstractComponent_actionPerformed(e);
      }
    });
    jMenuItemNewPropertySet.setText("New property set");
    jMenuItemNewPropertySet.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemNewPropertySet_actionPerformed(e);
      }
    });
    jMenuItemNewDataType.setText("New data type");
    jMenuItemNewDataType.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemNewDataType_actionPerformed(e);
      }
    });
    jTreeOpenFiles.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        jTreeOpenFiles_keyPressed(e);
      }
    });
    //jToolBar.add(jButton1);
	//jToolBar.add(jButton2);
	//jToolBar.add(jButton3);
	jMenuHelp.add(jMenuHelpAbout);
	jMenuBar1.add(jMenuFile);
	jMenuBar1.add(jMenuProject);

        jMenuItemCheck.setText("Check");
        jMenuItemCheck.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
          jMenuItemCheck_actionPerformed(e);
          }
        });

	// Get all tools from the ToolService
	Enumeration ts = ToolService.getTools();
	while (ts.hasMoreElements()) {
	    tools.add(ts.nextElement());
	}

	// Iterate through all tools and add menu items to the tools menu
	if (tools.size() > 0) {
	    for (int i = 0 ; i < tools.size(); i++) {
		CoCoTool tool = (CoCoTool)tools.elementAt(i);
		
		JMenuItem mi = new JMenuItem();
		mi.setText(tool.getMenuText());
		mi.setToolTipText(tool.getDescription());
		mi.setActionCommand("TOOL_" + i);
		mi.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
			    tool_actionPerformed(e);
			}
		    });
		
		jMenuTools.add(mi);
	    }

	} else {
	    // Add a 'no tools installed' item
	    JMenuItem mi = new JMenuItem();
	    mi.setText("no tools installed");
	    mi.setEnabled(false);
	    jMenuTools.add(mi);
	}

	jMenuBar1.add(jMenuTools);
	jMenuBar1.add(jMenuHelp);


	this.setJMenuBar(jMenuBar1);
	contentPane.add(jToolBar, BorderLayout.NORTH);
	contentPane.add(statusBar, BorderLayout.SOUTH);
	contentPane.add(jSplitPane2, BorderLayout.CENTER);
        outputPane.setPreferredSize(new Dimension(800,200));
        outputPane.setMaximumSize(new Dimension(800,200));
	jSplitPane2.add(outputPane, JSplitPane.BOTTOM);
	jSplitPane2.add(jSplitPane1, JSplitPane.TOP);

        //multiEdit.addDisplayTab("Messages");
        this.multiEdit.setMaximumSize(new Dimension(10,10));
        jSplitPane1.add(multiEdit, JSplitPane.RIGHT);

        jScrollPane2.setPreferredSize(new Dimension(200,200));
	jSplitPane1.add(jScrollPane2, JSplitPane.LEFT);
	jScrollPane2.getViewport().add(jTreeOpenFiles, null);
	jSplitPane2.setOneTouchExpandable(true);
        // commented out not yet implemented features
	jMenuFile.add(jMenuItemNewProject);
	jMenuFile.add(jMenuItemOpenProject);
        jMenuFile.add(jMenuItemSaveProject);
	jMenuFile.add(jMenuItemSaveProjectAs);
	jMenuFile.add(jMenuItemCloseProject);
	jMenuFile.addSeparator();

    // --- New Entity
    jMenu1.setText("New Entity...");
    jMenuFile.add(jMenu1);

    // ---- Add Entity
    jMenu2.setText("Add Entity...");
    jMenuFile.add(jMenu2);


//    jMenuFile.add(jMenuItem1);
	//jMenuFile.add(jMenuLoadRules);
	jMenuFile.addSeparator();
	jMenuFile.add(jMenuRecentFilesSub);

        // new ...
	jMenuFile.addSeparator();

	//jMenuFile.add(jMenuItemBrowseRepository);
	jMenuFile.add(jMenuItemOptions);
	jMenuFile.addSeparator();
	jMenuFile.add(jMenuQuit);

	jMenuRecentFilesSub.add(jMenuRecentProjects);
	//jMenuRecentFilesSub.add(jMenuRecentFiles);
	jMenuProject.add(jMenuItem4);

    jMenu1.add(jMenuItemNewComponent);
    jMenu1.add(jMenuItemNewAbstractComponent);
    jMenu1.add(jMenuItemNewPropertySet);
    jMenu1.add(jMenuItemNewDataType);

    // ---- Add Entity
    jMenuItemAddComponent.setText("Add Component File...");
    jMenuItemAddComponent.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemAddComponent_actionPerformed(e);
      }
    });

    jMenuItemAddAbstractComponent.setText("Add Abstract Component File...");
    jMenuItemAddAbstractComponent.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemAddAbstractComponent_actionPerformed(e);
      }
    });

    jMenuItemAddPropertySet.setText("Add Property Set File...");
    jMenuItemAddPropertySet.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemAddPropertySet_actionPerformed(e);
      }
    });

    jMenuItemAddDataType.setText("Add Data Type File...");
    jMenuItemAddDataType.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemAddDataType_actionPerformed(e);
      }
    });
    // ---



    jMenu2.add(jMenuItemAddComponent);
    jMenu2.add(jMenuItemAddAbstractComponent);
    jMenu2.add(jMenuItemAddPropertySet);
    jMenu2.add(jMenuItemAddDataType);

    jTreeOpenFiles.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
		public void valueChanged(TreeSelectionEvent e) {
		    jTreeOpenFiles_valueChanged(e);
		}
	     });

    pack();
    jSplitPane2.setDividerLocation(0.5);
  }

  void jMenuItemNewComponent_actionPerformed(ActionEvent e) {
    // Ask for name here
    //String name = NameDialog.showNameDialog(null, "Choose name");
    addComponent();
  }

  private void addComponent(){
    String name = NameDialog.showNameDialog(this, "Choose Name for Component", "Name", "Filename",
      new NameDialog.DialogHelperAdapter() {
        public String complete(String name) {return(name+".cm");}
      });

    if (name != null){
      this.controller.addNewComponentToProject(name);
    }

  }
  void jMenuItemNewAbstractComponent_actionPerformed(ActionEvent e) {
    addAbstractComponent();
  }

  private void addAbstractComponent(){
    String name = NameDialog.showNameDialog(this, "Choose Name for Abstract Component", "Name", "Filename",
       new NameDialog.DialogHelperAdapter() {
          public String complete(String name2) {return(name2+".acm");}
        });

    if (name != null){
      Controller controller = Controller.getInstance();
      controller.addNewAbstractComponentToProject(name);
    }

  }

  void jMenuItemNewPropertySet_actionPerformed(ActionEvent e) {
    addPropertySet();
  }

  private void addPropertySet(){
   String name = NameDialog.showNameDialog(this, "Choose Name for Property Set", "Name", "Filename",
       new NameDialog.DialogHelperAdapter() {
          public String complete(String name2) {return(name2+".prop");}
        });

    if (name != null){
      Controller controller = Controller.getInstance();
      controller.addNewPropertySetToProject(name);
    }

  }

  void jMenuItemNewDataType_actionPerformed(ActionEvent e) {
    addType();
  }

  private void addType(){
    String name = NameDialog.showNameDialog(this, "Choose Name for Data Type", "Name", "Filename",
       new NameDialog.DialogHelperAdapter() {
          public String complete(String name) {return(name+".type");}
        });

    if (name != null){
      Controller controller = Controller.getInstance();
      controller.addNewDataTypeToProject(name);
    }

  }

  void jTreeOpenFiles_keyPressed(KeyEvent e) {
    if(e.getKeyCode() == e.VK_N && e.getModifiers() == e.CTRL_MASK){
      CoCoTreeNode node = (CoCoTreeNode)jTreeOpenFiles.getLastSelectedPathComponent();
      if(node != null){
        if(node instanceof DatatypeListTreeNode)
          addType();
        else if(node instanceof ComponentListTreeNode)
          addComponent();
        else if(node instanceof AbstractComponentListTreeNode)
          addAbstractComponent();
        else if(node instanceof PropertySetListTreeNode)
          addPropertySet();
      }
    }

  }
}

