package coco.gui;

import javax.swing.tree.*;
import javax.swing.*;
import java.awt.Component;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public class CoCoTreeCellRenderer extends DefaultTreeCellRenderer {
  ImageIcon errorIcon = new ImageIcon("error.gif");

  public CoCoTreeCellRenderer() {
  }
  public Component getTreeCellRendererComponent(
    JTree tree,
    Object value,
    boolean sel,
    boolean expanded,
    boolean leaf,
    int row,
    boolean hasFocus){

    super.getTreeCellRendererComponent(
      tree, value, sel,expanded, leaf, row,hasFocus);
    if (isErrorNode(value)) {
      setIcon(errorIcon);
      setToolTipText("Shows errors that occured during parsing");
      System.out.println("Error node handling");
    } else {
      setToolTipText(null); //no tool tip
    }

    return this;
  }


  protected boolean isErrorNode(Object value) {
    DefaultMutableTreeNode node =
      (DefaultMutableTreeNode)value;
    String text =node.getUserObject().toString();
    if (text.compareTo("Errors") == 0) {
      return true;
    }
    return false;
  }

}
