package coco.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


import coco.utils.Assert;
/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class MessageBox extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButtonOk = new JButton();
  JButton jButtonCancel = new JButton();
  JPanel jPanel2 = new JPanel();
  JLabel jImageLabel = new JLabel();
  GridLayout gridLayout1 = new GridLayout();
  JLabel jLabel1 = new JLabel();

  public int answer;

  public static final int STYLE_OK = 0;
  public static final int STYLE_OKCANCEL = 1;
  public static final int STYLE_YESNO = 2;
  public static final int STYLE_YESNOCANCEL = 4;
  public static final int STYLE_DISMISS = 8;



  public static final int ANSWER_OK = 0;
  public static final int ANSWER_YES = 0;
  public static final int ANSWER_NO = 1;
  public static final int ANSWER_CANCEL = 2;
  JButton jButtonNo = new JButton();

  private int dialogStyle = STYLE_OK;
  private String dialogTitle = "Message";
  private String dialogMessage = "";
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextField jTextMessage = new JTextField();


  public MessageBox(String title, String message, int style) {
    Assert.require(message);
    Assert.require(message.length()>0);

    dialogMessage = message;
    if(title != null)
      dialogTitle = title;
    dialogStyle = style;

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  public void setStyle(int style){
   dialogStyle = style;
   switch(style){
    case STYLE_OK:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Ok");

      jButtonCancel.setVisible(false);
      jButtonNo.setVisible(false);
      break;
    case STYLE_DISMISS:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Dismiss");

      jButtonCancel.setVisible(false);
      jButtonNo.setVisible(false);
      break;



    case STYLE_OKCANCEL:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Ok");

      jButtonCancel.setVisible(true);
      jButtonCancel.setText("Cancel");

      jButtonNo.setVisible(false);
      break;

    case STYLE_YESNO:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Yes");

      jButtonNo.setVisible(true);
      jButtonNo.setText("No");

      jButtonCancel.setVisible(false);
      break;


    case STYLE_YESNOCANCEL:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Yes");

      jButtonNo.setVisible(true);
      jButtonNo.setText("No");

      jButtonCancel.setText("Cancel");
      jButtonCancel.setVisible(true);
      break;

    default:
      jButtonOk.setVisible(true);
      jButtonOk.setText("Ok");

      jButtonCancel.setVisible(false);
      jButtonNo.setVisible(false);
      break;


   }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    this.setModal(false);
    this.setTitle(dialogTitle);

    setStyle(dialogStyle);

    jButtonOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonOk_actionPerformed(e);
      }
    });

    jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonCancel_actionPerformed(e);
      }
    });
    jPanel2.setLayout(gridLayout1);
    jLabel1.setRequestFocusEnabled(false);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Message");
    jButtonNo.setToolTipText("");

    jButtonNo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonNo_actionPerformed(e);
      }
    });
    jTextMessage.setEditable(false);
    jButtonOk.setSelected(true);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButtonOk, null);
    jPanel1.add(jButtonNo, null);
    jPanel1.add(jButtonCancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.WEST);
    jPanel2.add(jImageLabel, null);
    this.getContentPane().add(jLabel1, BorderLayout.NORTH);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextMessage, null);

    this.setModal(true);
    jTextMessage.setText(this.dialogMessage);
    this.center();
    this.pack();
  }

  void jButtonOk_actionPerformed(ActionEvent e) {
    answer = this.ANSWER_OK;
    dispose();
  }

  void jButtonNo_actionPerformed(ActionEvent e) {
    answer = this.ANSWER_NO;
    dispose();

  }

  void jButtonCancel_actionPerformed(ActionEvent e) {
    answer = this.ANSWER_CANCEL;
    dispose();
  }


  void center(){
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

    Dimension frameSize = this.getSize();

    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

  }
}