package coco.gui;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.JFileChooser;

import java.awt.*;

import java.awt.event.*;
import java.util.*;

import coco.config.*;
import coco.utils.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class OptionDialog extends JDialog {
  JPanel jPanel2 = new JPanel();
  JButton jButtonCancel = new JButton();
  JPanel jPanel1 = new JPanel();
  JButton jButtonOk = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel2 = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JTable jTablePropTable = new JTable();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPopupMenu jPopupMenuOption = new JPopupMenu();
  JMenuItem jMenuItemAddOption = new JMenuItem();
  JMenuItem jMenuItemDeleteOption = new JMenuItem();
  JMenuItem jMenuItemEnterDirectory = new JMenuItem();

  public OptionDialog() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    pack();
  }
  private void jbInit() throws Exception {
    this.setTitle("Options");
    this.getContentPane().setLayout(borderLayout1);
    jButtonCancel.setToolTipText("");
    jButtonCancel.setText("Cancel");
    jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonCancel_actionPerformed(e);
      }
    });
    jButtonOk.setText("Ok");
    jButtonOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonOk_actionPerformed(e);
      }
    });
    jLabel2.setToolTipText("");
    jLabel2.setText("Program properties");
    jPanel2.setLayout(gridBagLayout1);
    jTablePropTable.setBorder(BorderFactory.createLineBorder(Color.black));
    jTablePropTable.setPreferredSize(new Dimension(454, 404));
    jTablePropTable.setColumnSelectionAllowed(true);

    jMenuItemAddOption.setText("Add option");
    jMenuItemAddOption.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemAddOption_actionPerformed(e);
      }
    });
    jMenuItemDeleteOption.setText("Delete option");
    jMenuItemDeleteOption.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemDeleteOption_actionPerformed(e);
      }
    });
    jMenuItemEnterDirectory.setText("Enter directory...");
    jMenuItemEnterDirectory.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemEnterDirectory_actionPerformed(e);
      }
    });
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jScrollPane1, new GridBagConstraints(0, 2, 3, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 8, 0, 10), -72, -163));
    jPanel2.add(jPanel1, new GridBagConstraints(1, 3, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(38, 35, 11, 58), 0, 0));
    jPanel1.add(jButtonOk, null);
    jPanel1.add(jButtonCancel, null);
    jPanel2.add(jLabel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(29, 8, 0, 0), 0, 0));
    jScrollPane1.getViewport().add(jTablePropTable, null);
    jPopupMenuOption.add(jMenuItemAddOption);
    jPopupMenuOption.add(jMenuItemDeleteOption);
    jPopupMenuOption.addSeparator();
    jPopupMenuOption.add(jMenuItemEnterDirectory);

    populateDialog();
    jTablePropTable.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTablePropTable_mouseClicked(e);
      }
    });

  }

  void populateDialog(){
    GlobalConfig config = GlobalConfig.getInstance();

    Properties options = config.getProperties();
    Properties copiedOptions = (Properties) options.clone();
    OptionTableModel model = new OptionTableModel(copiedOptions);
    jTablePropTable.setModel(model);
  }


  void jButtonOk_actionPerformed(ActionEvent e) {
    OptionTableModel model = (OptionTableModel) jTablePropTable.getModel();
    Properties props = model.getData();
    props.list(System.out);
    GlobalConfig c = GlobalConfig.getInstance();
    c.setProperties(props);
    try{
      c.writeConfig();
    }catch(java.io.IOException ex){
     ex.printStackTrace();
    }
    dispose();
  }

  void jButtonCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  void jMenuItemAddOption_actionPerformed(ActionEvent e) {
    OptionTableModel model = (OptionTableModel)jTablePropTable.getModel();
    model.addRow();

  }



  void jTablePropTable_mouseClicked(MouseEvent e) {
    if(e.getModifiers() == e.META_MASK){
      int r = jTablePropTable.getSelectedRow();
      int c = jTablePropTable.getSelectedColumn();
      this.jMenuItemDeleteOption.setEnabled(r != -1);
      this.jMenuItemEnterDirectory.setEnabled(c == 1);
      this.jPopupMenuOption.show(jTablePropTable, e.getX(), e.getY());

    }
  }

  void jMenuItemDeleteOption_actionPerformed(ActionEvent e) {
    OptionTableModel model = (OptionTableModel)jTablePropTable.getModel();
    int r = jTablePropTable.getSelectedRow();
    if(r != -1)
      model.deleteRow(r);
  }

  void jMenuItemEnterDirectory_actionPerformed(ActionEvent e) {
    int r = jTablePropTable.getSelectedRow();
    int c = jTablePropTable.getSelectedColumn();
    OptionTableModel model = (OptionTableModel)jTablePropTable.getModel();


    JFileChooser fileDlg = new JFileChooser();
    //fileDlg.setFileFilter(filter);
    fileDlg.setDialogTitle("Choose directory");
    fileDlg.setApproveButtonText("Choose");
    fileDlg.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

    // no file selected.
    if(JFileChooser.APPROVE_OPTION!=fileDlg.showOpenDialog(null)){
      System.out.println("No file selected");
      return;
    }

    String path = fileDlg.getSelectedFile().getPath();
    model.setValueAt(path, r, c);

  }


}

class OptionTableModel extends AbstractTableModel{
    private static final String[] columnNames= {"Option", "Current value"};
    private Vector modelDataKeys = null;
    private Vector modelDataValues = null;

    private Properties modelData = null;

    public OptionTableModel(Properties data){
      Assert.require(data);
      modelData = data;

      int len = modelData.size();
      // keys
      modelDataKeys = new Vector(len, 1);
      // values
      modelDataValues = new Vector(len, 1);

      Enumeration keys = modelData.keys();
      Enumeration values = modelData.elements();
      String key;
      String value;
      int i = 0;
      while(keys.hasMoreElements()){
        key = (String)keys.nextElement();
        value = (String)values.nextElement();
        modelDataKeys.add(i, key);
        modelDataValues.add(i, value);
        ++i;
      }
    }

    public Properties getData(){
    int sz1 = modelDataKeys.size();
    int sz2 = modelDataValues.size();

    System.out.println(sz1);
    System.out.println(modelDataKeys.toString());

    System.out.println(sz2);
    System.out.println(modelDataValues.toString());

     Assert.require(sz1 == sz2);
     modelData.clear();
     int maxIdx = modelDataKeys.size();
     for(int idx = 0; idx < maxIdx; idx++){
      modelData.setProperty((String)modelDataKeys.get(idx), (String)modelDataValues.get(idx));
     }
     return modelData;
    }

    public String getColumnName(int col) {
        Assert.require(col <= columnNames.length);
        return columnNames[col].toString();
    }

    public int getRowCount() { return modelDataKeys.size(); }
    public int getColumnCount() { return columnNames.length; }

    public Object getValueAt(int row, int col) {
      Object res = null;
      if(col == 0)
        res =  modelDataKeys.get(row);
      else if(col == 1)
        res = modelDataValues.get(row);

      return res;
    }
    public boolean isCellEditable(int row, int col){
        return true;
    }

    public void addRow(){
      int maxIdx = modelDataKeys.size();
      System.out.println("Row inserted");
      modelDataKeys.add(maxIdx, new String("New option"));
      modelDataValues.add(maxIdx, new String(""));

      this.fireTableRowsInserted(maxIdx,maxIdx);

    }

    public void deleteRow(int r){

      System.out.println("Row deleted");
      modelDataKeys.removeElementAt(r);
      modelDataValues.removeElementAt(r);
      this.fireTableRowsDeleted(r,r);
    }

    public void setValueAt(Object value, int row, int col) {
      System.out.print("Setting value at: ");System.out.print(row);System.out.println(col);
      int maxIdx = modelDataKeys.size();
      boolean rowAdded = false;
      if(row >= maxIdx){
        System.out.println("Row inserted");
        modelDataKeys.add(maxIdx, new String("New option"));
        modelDataValues.add(maxIdx, new String(""));
        rowAdded = true;
      }
      if(col==0)
        modelDataKeys.setElementAt((String)value, row);
      else if(col==1)
        modelDataValues.setElementAt((String)value, row);
      fireTableCellUpdated(row, col);
      if(rowAdded)
        this.fireTableRowsInserted(row,row);

     }
}
