package coco.gui;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.Component;
import coco.model.*;
import coco.model.nodes.*;
import coco.utils.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

//import coco.gui.editcontrols.*;
import javax.swing.tree.*;
import coco.config.*;
import java.io.*;
import coco.project.*;
import coco.filehandling.*;
import coco.model.commandsets.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public class TreePopupMenu extends JPopupMenu {
  private Controller controller = null;
  JMenuItem jMenuItemCheck = new JMenuItem();
  JMenuItem jMenuItemAddToProlog = new JMenuItem();
  JMenuItem jMenuItemRemoveNode = new JMenuItem();
  String FS = System.getProperty("file.separator");
  JTree jTree = null;
  int x=0,y=0;
  CoCoTreeNode currentNode = null;
  JMenuItem jMenuAddNode = new JMenuItem();
  JMenuItem jMenuItemStoreInProjectRepository = new JMenuItem();
  JMenuItem jMenuItemStoreInGeneralRepository = new JMenuItem();
  JMenuItem jMenuItemGenerateJava = new JMenuItem();
  //CoCoProject project = null;
  JMenuItem jMenuItemGenerateProlog = new JMenuItem();
  JMenuItem jMenuItemSaveCompilationUnit = new JMenuItem();
  CoCoFileFilter filter = new CoCoFileFilter();
  JMenuItem jMenuItemCompileCompilationUnit = new JMenuItem();



  /**
   * Populates the tree context menu, depending on the current tree node type
   * @param node The current tree node
   */

  public void prepare(CoCoTreeNode node){
    Assert.require(node);
    currentNode = node;
    this.removeAll();
    if(currentNode instanceof CoCoTreeNode){
      CoCoTreeNode n = (CoCoTreeNode)currentNode;
      CommandSet set = n.getCommandSet();
      if (set == null) return;
      Enumeration enum = set.getCommands();
      while(enum.hasMoreElements()){
        CommandSet.Command c = (CommandSet.Command)enum.nextElement();
        Assert.require(c);
        JMenuItem item = new JMenuItem(c.getText());
        item.addActionListener(new CommandActionAdapter(c));
        this.add(item);
      }
    }
  }

  public void show(Component invoker, int x, int y){
    if ((invoker != null) && (invoker instanceof JTree))
      { jTree = (JTree) invoker;
         this.x = x;
         this.y = y;
      }
    super.show(invoker, x, y);
  }

  public TreePopupMenu(Controller controller) {
    this.controller = controller;
  }

  private void jbInit() throws Exception {
  }

  void addCompilationUnit(CoCoTreeNode root) {
    Assert.require(root);
  }

  void addProperty(CoCoTreeNode node) {
  }

 /**
   * Wrapper class for tree node commands. Each node type defines its own command set
   */

  class CommandActionAdapter implements java.awt.event.ActionListener{
    CommandSet.Command command = null;
    public CommandActionAdapter(CommandSet.Command c){
      Assert.require(c);
      command = c;
    }
      public void actionPerformed(ActionEvent e) {
        command.execute(currentNode);
      }
  }
}
