package coco.gui.editor;

import javax.swing.text.Segment;
import org.gjt.sp.jedit.syntax.*;

/**
 * This class implements a simple token marker for the CoCo language.
 * It is simply derived from CTokenMarker, since the CoCo language uses
 * a syntax which has lots in common with C. Only the token table has been adapted
 * to the new language.
 * Besides this, the CTokenMarker serves as a basis for other C/C++/Java style languages
 */
public class CoCoTokenMarker extends CTokenMarker {


	public CoCoTokenMarker()
	{
		super(false,true,getKeywords());
	}

	public static KeywordMap getKeywords()
	{
		if(cocoKeywords == null)
		{
		    cocoKeywords = new KeywordMap(false);

		    // data types = Token.KEYWORD3
		    cocoKeywords.add("byte",Token.KEYWORD3);
		    cocoKeywords.add("char",Token.KEYWORD3);
		    cocoKeywords.add("short",Token.KEYWORD3);
		    cocoKeywords.add("int",Token.KEYWORD3);
		    cocoKeywords.add("long",Token.KEYWORD3);
		    cocoKeywords.add("float",Token.KEYWORD3);
		    cocoKeywords.add("double",Token.KEYWORD3);
		    cocoKeywords.add("bool",Token.KEYWORD3);
		    cocoKeywords.add("void",Token.KEYWORD3);

		    // general constructs = Token.KEYWORD1
		    cocoKeywords.add("component",Token.KEYWORD1);
		    cocoKeywords.add("port",Token.KEYWORD1);
		    cocoKeywords.add("property",Token.KEYWORD1);
		    cocoKeywords.add("connector",Token.KEYWORD1);
		    cocoKeywords.add("role",Token.KEYWORD1);
                    cocoKeywords.add("properties",Token.KEYWORD1);
		    // others = Token.KEYWORD2
		    cocoKeywords.add("package",Token.KEYWORD2);
		    cocoKeywords.add("abstract",Token.KEYWORD2);
		    cocoKeywords.add("active",Token.KEYWORD2);
		    cocoKeywords.add("extends",Token.KEYWORD2);
		    cocoKeywords.add("extern",Token.KEYWORD2);
		    cocoKeywords.add("event",Token.KEYWORD2);
		    cocoKeywords.add("false",Token.KEYWORD2);
		    cocoKeywords.add("has",Token.KEYWORD2);
		    cocoKeywords.add("is",Token.KEYWORD2);
		    cocoKeywords.add("in",Token.KEYWORD2);
		    cocoKeywords.add("inout",Token.KEYWORD2);
		    cocoKeywords.add("mandatory",Token.KEYWORD2);



		    cocoKeywords.add("optional",Token.KEYWORD2);
		    cocoKeywords.add("out",Token.KEYWORD2);
		    cocoKeywords.add("true",Token.KEYWORD2);
		    cocoKeywords.add("type",Token.KEYWORD2);

		}
		return cocoKeywords;
	}

	// private members
	private static KeywordMap cocoKeywords = null;
}
