package coco.gui.editor;

import org.gjt.sp.jedit.textarea.*;
import org.gjt.sp.jedit.syntax.*;

import javax.swing.*;
import java.awt.*;

/**
 * This class is a simple wrapper around JEditTextArea. It is an JPanel, containing a plain text 
 * editor. It also has a title, which can be set via the constructor.
 */

public class PlainEditor extends JPanel {

    String title;

    JEditTextArea textArea;

    public PlainEditor(String title) {
	super();

	this.title = title;

	init();
    }

    void init() {
	setLayout(new BorderLayout());

	textArea = new JEditTextArea();
	textArea.setTokenMarker(new PlainTokenMarker());

	InputHandler handler = new DefaultInputHandler();
	handler.addDefaultKeyBindings();
	textArea.setInputHandler(handler);

	add(textArea, BorderLayout.CENTER);
    }

    public String getTitle() {
	return(title);
    }

    public void setTitle(String s) {
	title = s;
    }

    public boolean hasChanged() {
	return(true);
    }

    public void setEditable(boolean e) {
	textArea.setEditable(e);
    }


    public String getText() {
	return(textArea.getText());
    }

    public void setText(String s) {
	textArea.setText(s);
    }

    public int getLineCount() {
	return(textArea.getLineCount());
    }

    public void goToLine(int line) {
	textArea.scrollTo(line, 0);
	int pos = textArea.getLineStartOffset(line);
	textArea.setCaretPosition(pos);
    }
}
