package coco.model;
import coco.model.nodes.*;
import javax.swing.*;
import javax.swing.tree.DefaultTreeCellRenderer;
import java.awt.Component;
/**
 * Title:        PECOS Composition Environment 2
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      FZI
 * @author
 * @version 1.0
 */

public class CoCoJTree extends JTree {

  private  boolean doPaint = true;

  public CoCoJTree() {
    super();
    ToolTipManager man = ToolTipManager.sharedInstance();
    man.registerComponent(this);
    man.setInitialDelay(10);
//    man.setLightWeightPopupEnabled(false);

    this.setCellRenderer(new MyRenderer());
  }




  public void treeDidChange() {
    revalidate();
      if (this.doPaint) {
        repaint();
      }
  }

  public void noPaint() {
    this.doPaint = false;
  }

  public void doPaint() {
    this.doPaint = true;
    this.treeDidChange();
  }

  class MyRenderer extends DefaultTreeCellRenderer{


    public Component getTreeCellRendererComponent(
      JTree tree,
      Object value,
      boolean sel,
      boolean expanded,
      boolean leaf,
      int row,
      boolean hasFocus){

      Component res = super.getTreeCellRendererComponent(
        tree, value, sel,expanded, leaf, row,hasFocus);
      if((value != null) && (value instanceof CoCoTreeNode)){
        if(leaf && (value instanceof ErrorTreeNode)){
          setToolTipText(((ErrorTreeNode)value).getDescription());
        }
        else
          setToolTipText(null);


        ImageIcon icon = ((CoCoTreeNode)value).getIcon();
        if(icon != null)
          setIcon(icon);
      }
      return res;
      }
  }


}