package coco.model.commandsets;

import java.util.Vector;
import java.util.Enumeration;
import coco.utils.Assert;
import coco.gui.MessageBox;
import coco.model.nodes.*;
import coco.model.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class AbstractComponentCommandSet extends CommandSet{
  public AbstractComponentCommandSet() {
    populate();
  }

  protected void populate(){
    super.populate();
    addCommand(
      new Command(){
        public String getText(){
          return "Remove Abstract Component";
        }
        public void execute(CoCoTreeNode data){
          Assert.require(data);
          if(!(data instanceof AbstractComponentTreeNode))
            return;
          MessageBox msg =
            new MessageBox("Question",
            "Do you really want to remove this abstract component from the project?",
            MessageBox.STYLE_YESNO);
            msg.show();
            if (msg.answer == MessageBox.ANSWER_YES){
             Controller controller = Controller.getInstance();
             controller.removeAbstractComponent((AbstractComponentTreeNode)data);
            }
        }
      }
    );




  }



}