package coco.model.commandsets;

import coco.utils.Assert;
import java.util.Vector;
import java.util.Enumeration;

import coco.model.nodes.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public abstract class CommandSet {

protected Vector commands = new Vector(10);


  public Enumeration getCommands(){
    Assert.require(commands);
    return commands.elements();
  }

  protected void addCommand(Command c){
    Assert.require(c);
    Assert.require(!commands.contains(c));
    commands.add(c);
  }

  protected void removeCommand(Command c){
    Assert.require(c);
    Assert.require(commands.contains(c));
    commands.remove(c);
  }


  protected void populate(){

  }

  public interface Command{
    public String getText();
    public void execute(CoCoTreeNode data);
  }
}