package coco.model.commandsets;

import java.util.Vector;
import java.util.Enumeration;
import coco.utils.Assert;
import coco.gui.MessageBox;
import coco.model.nodes.*;
import coco.model.*;
import java.io.File;
import coco.filehandling.*;
import coco.gui.NameDialog;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ComponentListCommandSet extends CommandSet{
  public ComponentListCommandSet() {
    populate();
  }

  protected void populate(){
    super.populate();
    addCommand(
      new Command(){
        public String getText(){
          return "New Component";
        }
        public void execute(CoCoTreeNode data){
          Assert.require(data);
          if(!(data instanceof ComponentListTreeNode))
            return;

          // Ask for name here
          //String name = NameDialog.showNameDialog(null, "Choose Component Name");
          String name = NameDialog.showNameDialog(null, "Choose Name for Abstract Component", "Name", "Filename",
             new NameDialog.DialogHelperAdapter() {
                public String complete(String name) {return(name+".cm");}
              });

          if (name != null){
            Controller controller = Controller.getInstance();
            controller.addNewComponentToProject(name);
          }

        }
      }
    );

    addCommand(
      new Command(){
        public String getText(){
          return "Add Component...";
        }
        public void execute(CoCoTreeNode data){
          Assert.require(data);
          openEntityFile(null);
        }
      }
    );
}
      private void openEntityFile(File param){
	File f = param;

	File[] files = null;
	if (f == null) {
	    files = FileService.doFileDialogMulti(new CoCoFileFilter());

	    if (files != null) {
		System.out.println("#files: " + files.length);
		for (int i = 0; i < files.length; i++) {
		    System.out.println(files[i]);
		    openEntityFile(files[i]);
		}
	    } else {
		System.out.println("Files are null");
	    }
	    return;
	}
        Controller controller = Controller.getInstance();
	controller.addComponentFileToProject(f);


  }



}