package coco.model.commandsets;

import java.util.Vector;
import java.util.Enumeration;
import coco.utils.Assert;
import coco.gui.MessageBox;
import coco.model.nodes.*;
import coco.model.*;
import coco.gui.NameDialog;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class DatatypeListCommandSet extends CommandSet{
  public DatatypeListCommandSet() {
    populate();
  }

  protected void populate(){
    super.populate();
    addCommand(
      new Command(){
        public String getText(){
          return "New Data Type";
        }
        public void execute(CoCoTreeNode data){
          Assert.require(data);
          if(!(data instanceof DatatypeListTreeNode))
            return;

          String name = NameDialog.showNameDialog(null, "Choose Name for Data Type", "Name", "Filename",
             new NameDialog.DialogHelperAdapter() {
                public String complete(String name) {return(name+".type");}
              });

          if (name != null){
            Controller controller = Controller.getInstance();
            controller.addNewDataTypeToProject(name);
          }

        }
      }
    );


  }
}