/* Generated By:JavaCC: Do not edit this line. CoCoParser.java */
package coco.parser;

import java.util.Vector;
import java.util.Hashtable;

import coco.parser.ast.*;
import coco.utils.Assert;
import coco.parser.symtab.SymtabDuplicateEntryException;


public class CoCoParser implements CoCoParserConstants {

        /**
	 * @contains ParseException
	 * parser stabilization still needs to be stabilized :-)
	 */
        static private Vector errors = new Vector(10);


        private static boolean standAlone = false;
        private static int numErrors = 0;



        /**
	 * Resets the parser (which is a static Java class)
	 * @param is the new input stream to read from
	 */

  public void reset(java.io.FileInputStream is){
        errors.removeAllElements();
        numErrors = 0;
        ReInit(is);
  }

        /**
	 * Resets the parser (which is a static Java class)
	 * @param is the new reader to read from
	 */
  public void reset(java.io.Reader r){
        errors.removeAllElements();
        numErrors = 0;
        ReInit(r);

  }

        /**
	 * Returns a vector containing all ParserException which were thrown during the last run
	 * @result a vector containing zero or more ParseExceptions
	 */

  public Vector getErrors(){
        return errors;
  }

        /**
	 * Returns true, if parsing was successful (i.e., no errors occurred)
	 */
  public boolean success(){
        return numErrors == 0;
  }

  /**
   * Serves as a test frame for the parser.
   * @param args only the first element of this array, if there is one, will be considered to be the name of a file from which to read.
   *
   */


  public static void main(String args[]) {
    CoCoParser parser;

                //erros.
    System.out.println("PECOS Composition Compiler Version 0.4a (CoCo V3), (c) FZI 2001");
    if (args.length == 0) {
      System.out.println("Reading from standard input . . .");
      parser = new CoCoParser(System.in);
    } else if (args.length == 1) {
      //System.out.println("Reading from file " + args[0] + " . . .");

      try {
        parser = new CoCoParser(new java.io.FileInputStream(args[0]));
      } catch (java.io.FileNotFoundException e) {
        System.out.println("Error: File " + args[0] + " not found.");
        return;
      }
    } else {

        System.out.println("This is free software which is licensed under the GPL.");
        System.out.println("A recent copy of the GPL can be obtained at http://www.gnu.org/copyleft/gpl.html");
                        System.out.println("SYNOPSIS:");
      System.out.println("java -jar cocop.jar < inputfile");
      System.out.println("OR");
      System.out.println("java -jar cocop.jar inputfile");
      System.out.println("If no input file is given, the parser reads from stdin.");
      return;
    }
    try {

        numErrors = 0;
        ASTCompilationUnit unit = parser.compilationUnit();
        standAlone = true;
      if(numErrors == 0){
        System.out.println(unit.toString());
                        }
                        else throw new ParseException("There were "+ Integer.toString(numErrors) + " error(s) during parsing");
    } catch (ParseException e) {
      System.out.println("Error:  Encountered errors during parsing.\n\n" + e.getMessage());

    }
  }

  static final public ASTCompilationUnit compilationUnit() throws ParseException {
        ASTCompilationUnit unit = null;
    if (jj_2_1(2)) {
      unit = propertySet();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case ACTIVE:
      case COMPONENT:
      case EVENT:
        unit = componentType();
        break;
      case TYPE:
        unit = dataTypeList();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(0);
                Assert.require(unit);
                try{
                        unit.register();
                } catch(SymtabDuplicateEntryException e){
                                        e.printStackTrace();
                                        {if (true) throw new ParseException();}
                }

                {if (true) return unit;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPropertySet propertySet() throws ParseException {
        ASTPropertySet res = null;
        ASTIdentifier id = null;
        ASTAbstractPropertyList propList = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPONENT:
      res = componentPropertySet();
      break;
    case PORT:
      res = portPropertySet();
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTComponentPropertySet componentPropertySet() throws ParseException {
        ASTIdentifier id = null;
        ASTAbstractPropertyList propList = null;
        ASTComponentPropertySet res = null;
    jj_consume_token(COMPONENT);
    jj_consume_token(PROPERTIES);
    id = identifier();
    jj_consume_token(L_BRACE);
    propList = abstractPropertyList();
    jj_consume_token(R_BRACE);

                res = new ASTComponentPropertySet(id, propList);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPortPropertySet portPropertySet() throws ParseException {
        ASTIdentifier id = null;
        ASTAbstractPropertyList propList = null;
        ASTPortPropertySet res = null;
    jj_consume_token(PORT);
    jj_consume_token(PROPERTIES);
    id = identifier();
    jj_consume_token(L_BRACE);
    propList = abstractPropertyList();
    jj_consume_token(R_BRACE);

                res = new ASTPortPropertySet(id, propList);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

/*

	Components are stateful entities that are responsible
	for computations.

*/
// (file suffix *.cm)
  static final public ASTComponentType componentType() throws ParseException {
        ASTComponentType res = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      res = abstractComponent();
      break;
    case ACTIVE:
    case COMPONENT:
    case EVENT:
      res = component();
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInterface abstractComponent() throws ParseException {
        ASTIdentifier id = null;
  ASTIdentifierList iList = null;
        ASTInterfaceBody body = null;
        ASTInterface res = null;
        ASTPropertySetReferenceList propSets = null;
    jj_consume_token(ABSTRACT);
    jj_consume_token(COMPONENT);
    id = identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      jj_consume_token(EXTENDS);
      iList = identifierList();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HAS:
      jj_consume_token(HAS);
      propSets = propertySetReferenceList();
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    body = abstractComponentBody();

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
                res = new ASTInterface(id, iList, propSets, body);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTComponent component() throws ParseException {
        ASTIdentifier id = null;
        ASTComponent res;
        ASTInterfaceIdentifierList iList = null;
        ASTComponentBody body = null;
        boolean active = false;
        boolean event = false;
        ASTPropertySetReferenceList propSets = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ACTIVE:
    case EVENT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ACTIVE:
        jj_consume_token(ACTIVE);
                                                 active = true;
        break;
      case EVENT:
        jj_consume_token(EVENT);
                                          event = true;
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    jj_consume_token(COMPONENT);
    id = identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS:
      jj_consume_token(IS);
      iList = interfaceIdentifierList();
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HAS:
      jj_consume_token(HAS);
      propSets = propertySetReferenceList();
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
    body = componentBody();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
                res = new ASTComponent(id, active,  iList, propSets, body);

                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

/*
 connectors are responsible for data transfer
 between components.
*/
  static final public ASTConnector connector() throws ParseException {
        ASTIdentifier id;
        ASTConnectorBody body = null;
        ASTPortAccessList ports;
        ASTPropertySetReferenceList propSets = null;
    jj_consume_token(CONNECTOR);
    id = identifier();
    jj_consume_token(L_PAREN);
    ports = portAccessList();
    jj_consume_token(R_PAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HAS:
      jj_consume_token(HAS);
      propSets = propertySetReferenceList();
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case L_BRACE:
      body = connectorBody();
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
                {if (true) return new ASTConnector(id, ports, propSets, body);}
    throw new Error("Missing return statement in function");
  }

/*	Defines data types of dataTypedata that is
	transmitted between components

	dataType specification --> spec of the structure of
  dataTypes that are transferred between components
 */
  static final public ASTDataTypeList dataTypeList() throws ParseException {
        ASTDataTypeList res;
        ASTDataType p;
    p = dataType();
                        res = new ASTDataTypeList(p);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYPE:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_1;
      }
      p = dataType();
                                res.addNode(p);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

/*
 *
 * Data types in coco are more or less the equivalent of C++ structs (in contrast to C++ structs)
 * data types can not declare methods and only support single inheritance
 * Data types can be inherited from another data type. The only restriction is, that this base
 * data type must also be a user defined data type. Thus it is not possible to inherit directly
 * from coco base types (like int or float)
 *
 */
  static final public ASTDataType dataType() throws ParseException {
        ASTDataType res = null;
        ASTIdentifier id;
        ASTBaseTypeReference btr = null;
        ASTIdentifier baseTypeId = null;
        ASTGenericTypeIdentifierList tlist = null;
        ASTFieldList fields = null;
    jj_consume_token(TYPE);
    id = identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      jj_consume_token(EXTENDS);
      baseTypeId = identifier();
                                btr = new ASTBaseTypeReference(baseTypeId);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
    jj_consume_token(L_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOL:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case EXTERN:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case VOID:
    case ID:
      fields = fieldList();
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    jj_consume_token(R_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
                res = new ASTDataType(id, btr, null/*reserved for genericity*/, fields /*, targetTypeName*/);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInterfaceBody abstractComponentBody() throws ParseException {
        ASTPortList ports = null;
        ASTAbstractPropertyList props = null;
        ASTInstanceList instances = null;
        ASTInstance inst = null;
        ASTRoleList roles = null;
        ASTRole role = null;
        ASTPort port = null;
        ASTAbstractProperty prop = null;
        ASTConnectorList connectors = null;
        ASTConnector conn = null;
    jj_consume_token(L_BRACE);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONNECTOR:
      case IN:
      case INOUT:
      case MANDATORY:
      case PROPERTY:
      case OPTIONAL:
      case OUT:
      case ROLE:
      case ID:
        ;
        break;
      default:
        jj_la1[18] = jj_gen;
        break label_2;
      }
      try {
        if (jj_2_2(2)) {
          port = port();
                                                if(ports == null)
                                                        ports = new ASTPortList(port);
                                                else
                                                        ports.addNode(port);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MANDATORY:
          case PROPERTY:
          case OPTIONAL:
            prop = abstractProperty();
                                                if(props == null)
                                                        props = new ASTAbstractPropertyList(prop);
                                                else
                                                        props.addNode(prop);
            break;
          case ROLE:
            role = role();
                                        if(roles == null)
                                                roles = new ASTRoleList(role);
                                        else
                                                roles.addNode(role);
            break;
          case ID:
            inst = instance();
                                        if(instances == null)
                                                instances = new ASTInstanceList(inst);
                                        else
                                                instances.addNode(inst);
            break;
          case CONNECTOR:
            conn = connector();
                                        if(connectors == null)
                                                connectors = new ASTConnectorList(conn);
                                        else
                                                connectors.addNode(conn);
            break;
          default:
            jj_la1[19] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      } catch (ParseException e) {
                                System.out.println("Caught exception");
                                int tokens[] = {PROPERTY, SEMICOLON, IN, OUT, INOUT, CONNECTOR, ROLE};
                                error_skipto_ex( tokens , e);
                                {if (true) return null;}
      }
    }
    jj_consume_token(R_BRACE);
                {if (true) return new ASTInterfaceBody(ports, props, roles, instances, connectors);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTComponentBody componentBody() throws ParseException {
        ASTPortList ports = null;
        ASTPropertyList props = null;
        ASTInstanceList instances = null;
        ASTInstance inst = null;
        ASTPort port = null;
        ASTProperty prop = null;

        ASTConnectorList connectors = null;
        ASTConnector conn = null;
    jj_consume_token(L_BRACE);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONNECTOR:
      case IN:
      case INOUT:
      case MANDATORY:
      case PROPERTY:
      case OPTIONAL:
      case OUT:
      case ID:
        ;
        break;
      default:
        jj_la1[20] = jj_gen;
        break label_3;
      }
      try {
        if (jj_2_3(2)) {
          port = port();
                                                if(ports == null)
                                                        ports = new ASTPortList(port);
                                                else
                                                        ports.addNode(port);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MANDATORY:
          case PROPERTY:
          case OPTIONAL:
            prop = property();
                                                if(props == null)
                                                        props = new ASTPropertyList(prop);
                                                else
                                                        props.addNode(prop);
            break;
          case ID:
            inst = instance();
                                        if(instances == null)
                                                instances = new ASTInstanceList(inst);
                                        else
                                                instances.addNode(inst);
            break;
          case CONNECTOR:
            conn = connector();
                                        if(connectors == null)
                                                connectors = new ASTConnectorList(conn);
                                        else
                                                connectors.addNode(conn);
            break;
          default:
            jj_la1[21] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      } catch (ParseException e) {
                                System.out.println("Caught exception");
                                int tokens[] = {PROPERTY, SEMICOLON, IN, OUT, INOUT, CONNECTOR};
                                error_skipto_ex( tokens , e);
                                {if (true) return null;}
      }
    }
    jj_consume_token(R_BRACE);
                {if (true) return new ASTComponentBody(ports, props, instances, connectors);}
    throw new Error("Missing return statement in function");
  }

/*
	Describes all component instances that are to be composed within a composite component

 */
  static final public ASTInstanceList instanceList() throws ParseException {
        ASTInstanceList res;
        ASTInstance inst;
    inst = instance();
                        res = new ASTInstanceList(inst);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        ;
        break;
      default:
        jj_la1[22] = jj_gen;
        break label_4;
      }
      inst = instance();
                                if(inst != null){
                                        res.addNode(inst);
                        }
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInstance instance() throws ParseException {
        ASTIdentifier varId;
        ASTComponentTypeIdentifier typeId;
        ASTRoleIdentifier roleId = null;
        ASTInstance res = null;
    try {
      typeId = componentTypeIdentifier();
      varId = identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IS:
        jj_consume_token(IS);
        roleId = roleIdentifier();
        break;
      default:
        jj_la1[23] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
                        res = new ASTInstance(varId, typeId, roleId);
                        {if (true) return res;}
    } catch (ParseException e) {
                // stabilizing
                error_skipto(SEMICOLON, e);
                {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

/*
	Describes roles for component instances that are to be composed within a composite component
	Roles can only appear in an abstract component. When a component inherits from an abstract component,
	all roles must be assigned a certain instance. The type of this instance must be a subtype of
	the type declared for this role.
 */
  static final public ASTRoleList roleList() throws ParseException {
        ASTRoleList res;
        ASTRole r;
    r = role();
                        res = new ASTRoleList(r);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ROLE:
        ;
        break;
      default:
        jj_la1[24] = jj_gen;
        break label_5;
      }
      r = role();
                                if(r != null){
                                        res.addNode(r);
                        }
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTRole role() throws ParseException {
        ASTIdentifier varId;
        ASTComponentTypeIdentifier typeId;
        ASTRole res = null;
    try {
      jj_consume_token(ROLE);
      typeId = componentTypeIdentifier();
      varId = identifier();
      jj_consume_token(SEMICOLON);
                        res = new ASTRole(varId, typeId);

                        {if (true) return res;}
    } catch (ParseException e) {
                // stabilizing
                error_skipto(SEMICOLON, e);
                {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

 /*
  *	ports are in, out or inout ports, they have a data type
  * and the are either optional (may be unbound in the final system)
  * or mandatory (must be bound, this is default)
  */
  static final public ASTPortList portList() throws ParseException {
        ASTPortList portList;
        ASTPort p;
    p = port();
                                portList = new ASTPortList(p);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IN:
      case INOUT:
      case MANDATORY:
      case OPTIONAL:
      case OUT:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_6;
      }
      p = port();
                                if(p != null)
                                        portList.addNode(p);
    }
                        {if (true) return portList;}
    throw new Error("Missing return statement in function");
  }

/*
 * A port can currently only be a data port. However, this might be loosened in the future
 * The grammar also allows for invocation or handler ports. In contrast to data ports,
 * handler/invocation ports have a formal parameter list.
 */
  static final public ASTPort port() throws ParseException {
        ASTPort res = null;
        ASTPortModifiers m = null;
        String dir = null;
        ASTDataTypeIdentifier t;
        boolean voidType = false;


        ASTInvocationSignature sig = null;
        ASTPortBody body = null;
        ASTIdentifier id = null;
        ASTPropertySetReferenceList propSets = null;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MANDATORY:
      case OPTIONAL:
        m = modifiers();
        break;
      default:
        jj_la1[26] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IN:
        jj_consume_token(IN);
                                             dir = token.image;
        break;
      case OUT:
        jj_consume_token(OUT);
                                               dir = token.image;
        break;
      case INOUT:
        jj_consume_token(INOUT);
                                                 dir = token.image;
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      t = dataTypeIdentifier();
      id = identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_PAREN:
        sig = signature();
        break;
      default:
        jj_la1[28] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HAS:
        jj_consume_token(HAS);
        propSets = propertySetReferenceList();
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_BRACE:
        body = portBody();
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[30] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                if(sig != null)
                        res = new ASTHandler(t, id, sig, propSets, body);
                else
                        res = new ASTData(t, id, propSets, body);


                if(m!=null)
                        res.setModifiers(m);

                Assert.require(t);
                res.setDataType(t);

                res.setDirection(dir);

                {if (true) return res;}
    } catch (ParseException e) {
                int tokens[] = {PRIVATE, PUBLIC, OPTIONAL, MANDATORY};
                error_skipto_ex( tokens , e);
                {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

  static final public ASTPortModifiers modifiers() throws ParseException {
        int m1 = ASTPortModifiers.IMPLICITELY;
        int m2 = ASTPortModifiers.IMPLICITELY;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MANDATORY:
      jj_consume_token(MANDATORY);
                              m1 = ASTPortModifiers.MANDATORY;
      break;
    case OPTIONAL:
      jj_consume_token(OPTIONAL);
                             m1 = ASTPortModifiers.OPTIONAL;
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return new ASTPortModifiers(m1, m2);}
    throw new Error("Missing return statement in function");
  }

/*
 * formal parameters of a handler (or, if existing in the model) invocation port
 */
  static final public ASTInvocationSignature signature() throws ParseException {
        ASTIdentifier id;
        ASTInvocationParameterList invocationParams = null;
    jj_consume_token(L_PAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOL:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case EXTERN:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case VOID:
    case ID:
      invocationParams = invocationParamList();
      break;
    default:
      jj_la1[32] = jj_gen;
      ;
    }
    jj_consume_token(R_PAREN);
                {if (true) return new ASTInvocationSignature(invocationParams);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPortBody portBody() throws ParseException {
        ASTPropertyList propList = null;
    jj_consume_token(L_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MANDATORY:
    case PROPERTY:
    case OPTIONAL:
      propList = propertyList();
      break;
    default:
      jj_la1[33] = jj_gen;
      ;
    }
    jj_consume_token(R_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[34] = jj_gen;
      ;
    }
                {if (true) return new ASTPortBody(propList);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPortAccessList portAccessList() throws ParseException {
        ASTPortAccessList res;
        ASTPortAccess acc;
    acc = portAccess();
                        res = new ASTPortAccessList(acc);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[35] = jj_gen;
        break label_7;
      }
      jj_consume_token(COMMA);
      acc = portAccess();
                                res.addNode(acc);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPortAccess portAccess() throws ParseException {
        ASTDesignator des;
        ASTInvocationParameterList epList = null;
    des = designator();
                {if (true) return new ASTPortAccess(des);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInvocationParameterList invocationParamList() throws ParseException {
        ASTInvocationParameterList res;
        ASTInvocationParameter param;
    param = invocationParam();
                        res = new ASTInvocationParameterList(param);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[36] = jj_gen;
        break label_8;
      }
      jj_consume_token(COMMA);
      param = invocationParam();
                                res.addNode(param);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInvocationParameter invocationParam() throws ParseException {
        ASTDataTypeIdentifier type;
        ASTIdentifier id;
    type = dataTypeIdentifier();
    id = identifier();
                {if (true) return new ASTInvocationParameter(type, id);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTFieldList fieldList() throws ParseException {
        ASTFieldList res;
        ASTField fld;
    fld = field();
                        res = new ASTFieldList(fld);
    jj_consume_token(SEMICOLON);
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOL:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case EXTERN:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case VOID:
      case ID:
        ;
        break;
      default:
        jj_la1[37] = jj_gen;
        break label_9;
      }
      fld = field();
                                res.addNode(fld);
      jj_consume_token(SEMICOLON);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTField field() throws ParseException {
        ASTIdentifier id;
        ASTDataTypeIdentifier type;
    type = dataTypeIdentifier();
    id = identifier();
                {if (true) return new ASTField(id, type);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTDataTypeIdentifierList dataTypeIdentifierList() throws ParseException {
        ASTDataTypeIdentifierList res;
        ASTDataTypeIdentifier id;
    id = dataTypeIdentifier();
                        res = new ASTDataTypeIdentifierList(id);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[38] = jj_gen;
        break label_10;
      }
      jj_consume_token(COMMA);
      id = dataTypeIdentifier();
                                res.addNode(id);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTDataTypeIdentifier dataTypeIdentifier() throws ParseException {
        ASTDataTypeIdentifier dataTypeTypeId = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOL:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case VOID:
      dataTypeTypeId = baseTypeIdentifier();
      break;
    case EXTERN:
    case ID:
      dataTypeTypeId = userTypeIdentifier();
      break;
    default:
      jj_la1[39] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return dataTypeTypeId;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPropertySetReferenceList propertySetReferenceList() throws ParseException {
        ASTPropertySetReferenceList res;
        ASTPropertySetReference id;
    id = propertySetReference();
                        res = new ASTPropertySetReferenceList(id);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[40] = jj_gen;
        break label_11;
      }
      jj_consume_token(COMMA);
      id = propertySetReference();
                                res.addNode(id);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPropertySetReference propertySetReference() throws ParseException {
        ASTPropertySetReference res= null;
    jj_consume_token(ID);
    dummy();
                res = new ASTPropertySetReference(token.image);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTUserTypeIdentifier userTypeIdentifier() throws ParseException {
        ASTIdentifier idType;
        Vector dimensions = new Vector(2);
        int currentDim = 0;
        boolean ext = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTERN:
      jj_consume_token(EXTERN);
                                        ext = true;
      break;
    default:
      jj_la1[41] = jj_gen;
      ;
    }
    idType = identifier();
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_BRACKET:
        ;
        break;
      default:
        jj_la1[42] = jj_gen;
        break label_12;
      }
      jj_consume_token(L_BRACKET);
      jj_consume_token(DECIMALINT);
                                                                                        dimensions.add(currentDim, new Integer(token.image));
      jj_consume_token(R_BRACKET);
                                                                currentDim++;
    }
                        if(dimensions.isEmpty()){
                                dimensions = null;
                        }
                        {if (true) return new      ASTUserTypeIdentifier(idType, ext, dimensions);}
    throw new Error("Missing return statement in function");
  }

/*
 * Coco provides a set of primitive base types. This set basically resembles more or less
 * the base types known from Java or C++.
 * Maybe one has to change the grammar here since there is actually a difference between
 * the actual base (primitive) type and its usage as an array type. The same applies for user
 * types. Atleast the name should be changed (to something like TypeReference) to reflect
 * the real meaning of this construct. (TG)
 */
  static final public ASTBaseTypeIdentifier baseTypeIdentifier() throws ParseException {
        ASTIdentifier idType;
        Vector dimensions = new Vector(2);
        int currentDim = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INT:
      jj_consume_token(INT);
      break;
    case BOOL:
      jj_consume_token(BOOL);
      break;
    case CHAR:
      jj_consume_token(CHAR);
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
      break;
    case SHORT:
      jj_consume_token(SHORT);
      break;
    case LONG:
      jj_consume_token(LONG);
      break;
    case BYTE:
      jj_consume_token(BYTE);
      break;
    case VOID:
      jj_consume_token(VOID);
      break;
    default:
      jj_la1[43] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                idType = new ASTIdentifier(token.image);
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_BRACKET:
        ;
        break;
      default:
        jj_la1[44] = jj_gen;
        break label_13;
      }
      jj_consume_token(L_BRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DECIMALINT:
        jj_consume_token(DECIMALINT);
                                                                                        dimensions.add(currentDim, new Integer(token.image));
        break;
      default:
        jj_la1[45] = jj_gen;
        ;
      }
      jj_consume_token(R_BRACKET);
                                                                currentDim++;
    }
                        if(dimensions.isEmpty()){
                                dimensions = null;
                        }
                        {if (true) return new      ASTBaseTypeIdentifier(idType, dimensions);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTConnectorBody connectorBody() throws ParseException {
        ASTPropertyList propList = null;
    jj_consume_token(L_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MANDATORY:
    case PROPERTY:
    case OPTIONAL:
      propList = propertyList();
      break;
    default:
      jj_la1[46] = jj_gen;
      ;
    }
    jj_consume_token(R_BRACE);
                {if (true) return new ASTConnectorBody(propList);}
    throw new Error("Missing return statement in function");
  }

 /*
 	properties of a component have a type (int, float, string, or enum)
 	and may have an initial value. Mandatory properties (the default)
 	must be bound at least in the final system. Optional properties may
 	not be bound. The distinction between abstract and 'normal' properties
 	is artificial (it makes it easier to deal with those two kinds of properties
 	differently afterwards. Abstract properties can only appear within an abstract
 	component or within a property set definition while normal properties can
 	appear within components, ports, connectors
 */
  static final public ASTAbstractPropertyList abstractPropertyList() throws ParseException {
        ASTAbstractProperty prop;
        ASTAbstractPropertyList propList;
    prop = abstractProperty();
                        propList = new ASTAbstractPropertyList(prop);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MANDATORY:
      case PROPERTY:
      case OPTIONAL:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_14;
      }
      prop = abstractProperty();
                                if(prop != null)
                                        propList.addNode(prop);
    }
                {if (true) return propList;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPropertyList propertyList() throws ParseException {
        ASTProperty prop;
        ASTPropertyList propList;
    prop = property();
                        propList = new ASTPropertyList(prop);
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MANDATORY:
      case PROPERTY:
      case OPTIONAL:
        ;
        break;
      default:
        jj_la1[48] = jj_gen;
        break label_15;
      }
      prop = property();
                                if(prop != null)
                                        propList.addNode(prop);
    }
                {if (true) return propList;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTProperty property() throws ParseException {
        ASTPropertyIdentifier id;
        ASTConstExpression expr = null;
        int mandatory = ASTProperty.IMPLICITELY_MANDATORY;
        ASTProperty res  = null;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MANDATORY:
      case OPTIONAL:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OPTIONAL:
          jj_consume_token(OPTIONAL);
                                mandatory = ASTProperty.OPTIONAL;
          break;
        case MANDATORY:
          jj_consume_token(MANDATORY);
                                mandatory = ASTProperty.MANDATORY;
          break;
        default:
          jj_la1[49] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[50] = jj_gen;
        ;
      }
      jj_consume_token(PROPERTY);
      id = propertyIdentifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSGMNT:
        jj_consume_token(ASSGMNT);
        expr = constExpression();
        break;
      default:
        jj_la1[51] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
                        res = new ASTProperty(id, expr, mandatory);

                        {if (true) return res;}
    } catch (ParseException e) {
        System.out.println("Caught exception");
        int tokens[] = {PROPERTY, SEMICOLON, IN, OUT, INOUT};
        error_skipto_ex( tokens , e);
        {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

  static final public ASTAbstractProperty abstractProperty() throws ParseException {
        ASTAbstractProperty res = null;

        ASTConstExpression expr = null;
        ASTPropertyIdentifier id;

        int mandatory = ASTProperty.IMPLICITELY_MANDATORY;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MANDATORY:
      case OPTIONAL:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OPTIONAL:
          jj_consume_token(OPTIONAL);
                        mandatory = ASTProperty.OPTIONAL;
          break;
        case MANDATORY:
          jj_consume_token(MANDATORY);
                        mandatory = ASTProperty.MANDATORY;
          break;
        default:
          jj_la1[52] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[53] = jj_gen;
        ;
      }
      jj_consume_token(PROPERTY);
      id = propertyIdentifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSGMNT:
        jj_consume_token(ASSGMNT);
        expr = constExpression();
        break;
      default:
        jj_la1[54] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
                res = new ASTAbstractProperty(id, expr, mandatory);
                {if (true) return res;}
    } catch (ParseException e) {
        int tokens[] = {PROPERTY, ID};
        error_skipto_ex( tokens , e);
        {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

  static final public ASTConstExpressionList constExpressionList() throws ParseException {
        ASTConstExpressionList res;
        ASTConstExpression expr;
    expr = constExpression();
                res = new ASTConstExpressionList(expr);
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[55] = jj_gen;
        break label_16;
      }
      jj_consume_token(COMMA);
      expr = constExpression();
                                           res.addNode(expr);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTBoolLiteral boolLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
      break;
    case FALSE:
      jj_consume_token(FALSE);
      break;
    default:
      jj_la1[56] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                 {if (true) return new ASTBoolLiteral(new String(token.image));}
    throw new Error("Missing return statement in function");
  }

  static final public ASTConstExpression constExpression() throws ParseException {
 ASTLiteral lit;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OCTALINT:
    case DECIMALINT:
    case HEXADECIMALINT:
    case FLOATONE:
    case FLOATTWO:
      lit = numericLiteral();
      break;
    case CHARACTER:
      lit = charLiteral();
      break;
    case STRING:
      lit = stringLiteral();
      break;
    case FALSE:
    case TRUE:
      lit = boolLiteral();
      break;
    case L_BRACE:
      lit = mappingLiteral();
      break;
    default:
      jj_la1[57] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return new ASTConstExpression(lit);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTMappingLiteral mappingLiteral() throws ParseException {
        ASTConstExpression paramExpr = null;
        ASTConstExpression valueExpr = null;
        ASTMappingLiteral res = null;
    jj_consume_token(L_BRACE);
    jj_consume_token(L_PAREN);
    paramExpr = constExpression();
    jj_consume_token(COMMA);
    valueExpr = constExpression();
    jj_consume_token(R_PAREN);
                                res = new ASTMappingLiteral(new ASTMapping(paramExpr, valueExpr));
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[58] = jj_gen;
        break label_17;
      }
      jj_consume_token(COMMA);
      jj_consume_token(L_PAREN);
      paramExpr = constExpression();
      jj_consume_token(COMMA);
      valueExpr = constExpression();
      jj_consume_token(R_PAREN);
                                res.addNode(new ASTMapping(paramExpr, valueExpr));
    }
    jj_consume_token(R_BRACE);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTNumericLiteral numericLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OCTALINT:
      jj_consume_token(OCTALINT);
                        {if (true) return new ASTIntLiteral(token.image);}
      break;
    case DECIMALINT:
      jj_consume_token(DECIMALINT);
                        {if (true) return new ASTIntLiteral(token.image);}
      break;
    case HEXADECIMALINT:
      jj_consume_token(HEXADECIMALINT);
                                {if (true) return new ASTIntLiteral(token.image);}
      break;
    case FLOATONE:
      jj_consume_token(FLOATONE);
                                {if (true) return new ASTFloatLiteral(token.image);}
      break;
    case FLOATTWO:
      jj_consume_token(FLOATTWO);
                        {if (true) return new ASTFloatLiteral(token.image);}
      break;
    default:
      jj_la1[59] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public ASTCharLiteral charLiteral() throws ParseException {
    jj_consume_token(CHARACTER);
                {if (true) return new ASTCharLiteral(token.image);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTStringLiteral stringLiteral() throws ParseException {
    jj_consume_token(STRING);
                {if (true) return new ASTStringLiteral(token.image);}
    throw new Error("Missing return statement in function");
  }

  static final public ASTIdentifierList identifierList() throws ParseException {
        ASTIdentifier id;
        ASTIdentifierList idList;
    id = identifier();
                 idList = new ASTIdentifierList(id);
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[60] = jj_gen;
        break label_18;
      }
      jj_consume_token(COMMA);
      id = identifier();
                                idList.addNode(id);
    }
                        {if (true) return idList;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInterfaceIdentifierList interfaceIdentifierList() throws ParseException {
        ASTInterfaceIdentifier id;
        ASTInterfaceIdentifierList iList;
    id = interfaceIdentifier();
                 iList = new ASTInterfaceIdentifierList(id);
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[61] = jj_gen;
        break label_19;
      }
      jj_consume_token(COMMA);
      id = interfaceIdentifier();
                                iList.addNode(id);
    }
                        {if (true) return iList;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTInterfaceIdentifier interfaceIdentifier() throws ParseException {
        ASTInterfaceIdentifier res;
    jj_consume_token(ID);
    dummy();
                res = new ASTInterfaceIdentifier(token.image);

                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTPropertyIdentifier propertyIdentifier() throws ParseException {
        ASTPropertyIdentifier res;
        ASTDesignator des = null;
    des = designator();
                res = new ASTPropertyIdentifier(des);


                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTComponentTypeIdentifier componentTypeIdentifier() throws ParseException {
        ASTComponentTypeIdentifier res;
    jj_consume_token(ID);
    dummy();
                res = new ASTComponentTypeIdentifier(token.image);

                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTRoleIdentifier roleIdentifier() throws ParseException {
        ASTRoleIdentifier res;
    jj_consume_token(ID);
    dummy();
                res = new ASTRoleIdentifier(token.image);

                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTDesignator designator() throws ParseException {
        ASTIdentifier id;
        ASTDesignator res;
    id = identifier();
                        res = new ASTDesignator(id);
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[62] = jj_gen;
        break label_20;
      }
      jj_consume_token(DOT);

      id = identifier();
                        res.addNode(id);
    }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static final public ASTIdentifier identifier() throws ParseException {
        ASTIdentifier res = null;
    jj_consume_token(ID);
    dummy();
                res = new ASTIdentifier(token.image);

                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  static void error_skipto(int kind, ParseException e) throws ParseException, ParseException {
         numErrors++;

         System.out.println(e.toString());
         System.out.println("Stabilizing...");
//	 ParseException e = generateParseException();  // generate the exception object.
//	 System.out.println(e.toString());  // print the error message
         Token t;
         do {
                 t = getNextToken();
                 // The above loop consumes tokens all the way upto a token of
                 // "kind".  We use a do-while loop rather than a while because the
                 // current token is the one immediately before the erroneous token
                 // (in our case the token immediately before what should have been there
         } while ((t.kind != kind) && (t.kind != EOF));
  }

  static void error_skipto_ex(int kind[], ParseException e) throws ParseException, ParseException {
         numErrors++;

         System.out.println(e.toString());
         System.out.println("Stabilizing...");
//	 ParseException e = generateParseException();  // generate the exception object.
//	 System.out.println(e.toString());  // print the error message
         Token t;
         int len = kind.length;
         boolean found = false;

         int idx = 0;
         boolean eof = false;
         while(!found && !eof){
                 t = getNextToken();
                 eof = (t.kind == EOF);
                 for(idx=0; (idx<len) && (!found); idx++){
                  found = (t.kind == kind[idx]);

                 }
         }

         // we found one of the tokens in the given array. now push it back onto the token stream
         if(found){
                Assert.require(idx <= tokenImage.length);
                idx--; // we are one position further than we want to be (post-fix increment in for loop, see above)
                String image = tokenImage[kind[idx]];
                System.out.println(idx);
                System.out.println("On token "+ image);
                int pushBackLen = image.length() - 2;
                if(pushBackLen > 0)
                        jj_input_stream.backup(pushBackLen);
                else
                        jj_input_stream.backup(1);
   }else
    throw e;
  }

  static void dummy() throws ParseException {
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  static final private boolean jj_3R_24() {
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_23() {
    if (jj_3R_30()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_34() {
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_29() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_47() {
    if (jj_scan_token(VOID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_46() {
    if (jj_scan_token(BYTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_45() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_22() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_25()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_26()) {
    jj_scanpos = xsp;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_29()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_28() {
    if (jj_scan_token(INOUT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_44() {
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_27() {
    if (jj_scan_token(OUT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_21() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_43() {
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_42() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_36() {
    if (jj_scan_token(OPTIONAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_26() {
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_41() {
    if (jj_scan_token(CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_35() {
    if (jj_scan_token(MANDATORY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_40() {
    if (jj_scan_token(BOOL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_39() {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_31() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(PROPERTIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_48() {
    if (jj_scan_token(EXTERN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_35()) {
    jj_scanpos = xsp;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3R_44()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_25() {
    if (jj_3R_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_38() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_48()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_49() {
    if (jj_scan_token(ID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_33() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_30() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(PROPERTIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public CoCoParserTokenManager token_source;
  static ASCII_CharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[63];
  static final private int[] jj_la1_0 = {0x21180,0x20001000,0x21180,0x8000,0x100000,0x0,0x20100,0x20100,0x400000,0x100000,0x0,0x100000,0x0,0x0,0x0,0x8000,0x6094e00,0x0,0x9802000,0x8002000,0x9802000,0x8002000,0x0,0x400000,0x0,0x9800000,0x8000000,0x1800000,0x0,0x100000,0x0,0x8000000,0x6094e00,0x8000000,0x0,0x0,0x0,0x6094e00,0x0,0x6094e00,0x0,0x10000,0x0,0x6084e00,0x0,0x0,0x8000000,0x8000000,0x8000000,0x8000000,0x8000000,0x0,0x8000000,0x8000000,0x0,0x0,0x40000,0x40000,0x0,0x0,0x0,0x0,0x0,};
  static final private int[] jj_la1_1 = {0x100,0x0,0x0,0x0,0x0,0x800000,0x0,0x0,0x0,0x0,0x800000,0x0,0x80000,0x800000,0x100,0x0,0x640,0x800000,0x439,0x429,0x419,0x409,0x400,0x0,0x20,0x18,0x8,0x10,0x20000,0x0,0x880000,0x8,0x640,0x9,0x800000,0x0,0x0,0x640,0x0,0x640,0x0,0x0,0x200000,0x240,0x200000,0x1000,0x9,0x9,0x9,0x8,0x8,0x10000,0x8,0x8,0x10000,0x0,0x80,0x8f880,0x0,0xf800,0x0,0x0,0x0,};
  static final private int[] jj_la1_2 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x2,0x0,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x30,0x2,0x0,0x2,0x2,0x8,};
  static final private JJCalls[] jj_2_rtns = new JJCalls[3];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public CoCoParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new CoCoParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public CoCoParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new CoCoParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public CoCoParser(CoCoParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(CoCoParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 63; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[72];
    for (int i = 0; i < 72; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 63; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 72; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 3; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
