package coco.parser;
import coco.utils.Assert;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ParserService {
  static private CoCoParser cocoParser = null;

/**
 * getCoCoParser returns an instance of a coco parser, that reads from a FileInputStream.
 * An assertion fails if is is null.
 * @param is - the FileInputStream to read from
 * @return  an instance of CoCoParser
 */
  static final public CoCoParser getCoCoParser(java.io.FileInputStream is){
    Assert.require(is);
    if(cocoParser == null){
     cocoParser = new CoCoParser(is);
    }else{
     cocoParser.reset(is);
    }
    return cocoParser;
  }

/**
 * getCoCoParser returns an instance of a coco parser, that reads from a Reader.
 * An assertion fails if r is null.
 * @param r the Reader to read from
 * @return  an instance of CoCoParser
 */
  static final public CoCoParser getCoCoParser(java.io.Reader r){
    Assert.require(r);
    if(cocoParser == null){
     cocoParser = new CoCoParser(r);
    }else{
     cocoParser.reset(r);
    }
    return cocoParser;
  }

}