package coco.parser.ast;
import java.util.*;
import coco.utils.*;
import coco.parser.ast.enums.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

// seems to be strange that the abstract list inherits from PropertyList
// However, this makes sense: an abstract list (abstract properties being
// properties without init expression) is allowed wherever a propertyList is
// allowed but not vice versa --> (LSP: sub class is substituable for their base class).


public class ASTAbstractPropertyList extends ASTPropertyList {
  private Node parent = null;

  public ASTAbstractPropertyList(ASTAbstractProperty prop) {
    super(prop);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTAbstractProperty);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new PropertyEnumeration(container);
  }
}