package coco.parser.ast;
import coco.utils.Assert;
import java.util.Vector;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTBaseTypeIdentifier extends ASTDataTypeIdentifier {

  public ASTBaseTypeIdentifier(String typeId) {
    super(typeId);
  }

  public ASTBaseTypeIdentifier(ASTIdentifier type, Vector dims){
    super(type, dims);
  }

  public boolean isBuiltInType(){
    return true;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    Assert.require(typeId);
    typeId.accept(v, data);
    // todo: take care of the dimension stuff


    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}