package coco.parser.ast;
import coco.utils.*;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTBaseTypeReference extends GenericNode {
  ASTIdentifier typeId;
  public ASTBaseTypeReference(ASTIdentifier ti) {
    Assert.require(ti);
    typeId = ti;

  }

  public String toString(){
    return typeId.toString();
  }

  public ASTIdentifier getTypeId(){
    return typeId;
  }

  public void setTypeId(ASTIdentifier ti){
    Assert.require(ti);
    typeId = ti;
  }


  public Object accept(AbstractASTVisitor v, Object data) {
   if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(typeId);
    typeId.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
   }
}