package coco.parser.ast;
import coco.utils.Assert;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTCharLiteral extends GenericNode implements ASTLiteral{

  Character value = null;
  public ASTCharLiteral(String val) {
    setValue(val);
  }

  public ASTCharLiteral(){
  }

  public String getValue(){
    return value.toString();
  }

  public void setValue(String val){
    Assert.require(val.length()==1);
    value = new Character(val.charAt(0));
  }
  public String toString(){
    return value.toString();
  }

  public char getCharValue(){
    return value.charValue();
  }

 public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    // no subnodes
    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}