package coco.parser.ast;
import coco.parser.ParseException;
import coco.parser.symtab.SymtabDuplicateEntryException;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public interface ASTCompilationUnit{
  public void setSourceFile(java.io.File f);
  public java.io.File getSourceFile();
  public void register() throws coco.parser.symtab.SymtabDuplicateEntryException;
  public void unregister(); //for removing from the symbol table
  public String getUnitName();
  public String getUnitType();
  public Object accept(AbstractASTVisitor v, Object data);


}