package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTConnectorBody extends GenericNode {
  private ASTConnector parent = null;
  private ASTPropertyList propList = null;


  public ASTConnectorBody(ASTPropertyList pl) {
    propList = pl;
  }

  public ASTPropertyList getPropertyList() {
  return propList;
  }

 /**
  * setPropertyList sets the proplist of ASTConnectorBody. Parameter can be null also, since it is not a necessary feature
  * according to CoCo grammar.
  * @param propList   PropertyList of the ASTConnectorBody
  */

 public void setPropertyList(ASTPropertyList pl) {
   this.propList = pl;
   Assert.require(parent);
   if(propList != null)
    propList.setParent(parent);

 }

  public String toString(){
    String res = "{\n";
    if(propList !=null)
      res += propList.toString();
    res += "\n}";
    return res;
  }

  public String toPrologString(){
    String res = "";
    if(propList != null)
      res = propList.toPrologString();
    return res;
  }

  public void setParent(Node n){
    Assert.require(n);
    Assert.require(n instanceof ASTConnector);
    parent = (ASTConnector)n;
    // set the parent link for the properties if there are any
    if(propList != null)
      propList.setParent(parent);

  }
  public Node getParent(){
    return parent;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    if(propList != null)
      propList.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}