package coco.parser.ast;
import coco.utils.*;
/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTConstExpression extends GenericNode{
  public ASTLiteral lit;
  public ASTConstExpression(ASTLiteral l) {
    Assert.require(l);
    lit = l;
  }

  public String toString(){
    return lit.toString();
  }

  public  ASTLiteral getLiteral() {
  return lit;
  }

  public String toPrologString(){
    return lit.toPrologString();
  }


  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the subnodes
    lit.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}