package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTConstExpressionList extends GenericContainerNode {

  public ASTConstExpressionList(ASTConstExpression e){
    super();
    addNode(e);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTConstExpression);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new ConstExpressionEnumeration(container);
  }

  public String toString(){
    ConstExpressionEnumeration enum = (ConstExpressionEnumeration) getNodes();
    String res = "";
    ASTConstExpression c;
    while(enum.hasMoreElements()){
      c = (ASTConstExpression) enum.nextElement();
      res+= c.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }
  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    ConstExpressionEnumeration enum = (ConstExpressionEnumeration) getNodes();
    ASTConstExpression elem;
    while(enum.hasMoreElements()){
      elem = (ASTConstExpression) enum.nextElement();
      elem.setParent(n);
    }
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    ConstExpressionEnumeration enum = (ConstExpressionEnumeration) getNodes();
    ASTConstExpression c;
    while(enum.hasMoreElements()){
      c = (ASTConstExpression) enum.nextElement();
      c.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);



    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
