package coco.parser.ast;
import coco.utils.*;
import java.util.Vector;
import java.util.Enumeration;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

abstract public class ASTDataTypeIdentifier extends GenericNode {

  protected ASTIdentifier typeId;
  protected Vector dimensions = null;
  protected int numberOfDims = 0;


  public ASTDataTypeIdentifier(String type) {
    Assert.require(type);
    Assert.require(type!="");
    typeId = new ASTIdentifier(type);
  }
  public ASTDataTypeIdentifier(ASTIdentifier type, Vector dims) {
    Assert.require(type);
    typeId = type;
    dimensions = dims;
    if(dimensions != null)
      numberOfDims = dimensions.size();
    else
      numberOfDims = 0;

  }

  public boolean isArrayType(){
    return numberOfDims >0;
  }

  public Vector getDimensions(){
    return dimensions;
  }

  public void setDimensions(Vector dims){
    dimensions = dims;
    if(dimensions != null)
      numberOfDims = dimensions.size();
    else
      numberOfDims = 0;

  }
  public boolean isBuiltInType(){
    return false;
  }

  public ASTDataType getDefiningDataType(){
    return null;
  }

  public ASTIdentifier getTypeID() {
    return(typeId);
  }

  public String toString(){
    String res = typeId.toString();
    if(numberOfDims > 0){

     for(int i = 0; i < numberOfDims;i++){
      res += "[";
      if(dimensions != null){
        Integer d = (Integer) dimensions.get(i);
        res +=  "[" ;
        if(d != null){
          res += d.toString();
        }
      }
      res += "]";
     }
    }
    return res;
  }

  public String toPrologString(){
    String res = typeId.toPrologString();
    return res;
  }

 abstract public Object accept(AbstractASTVisitor v, Object data);

}