package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTDataTypeIdentifierList extends GenericContainerNode {

  public ASTDataTypeIdentifierList(ASTDataTypeIdentifier p){
    super();
    addNode(p);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTDataTypeIdentifier);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new DataTypeIdentifierEnumeration(container);
  }

  public String toString(){
    DataTypeIdentifierEnumeration enum = (DataTypeIdentifierEnumeration) getNodes();
    String res = "";
    ASTDataTypeIdentifier t;
    while(enum.hasMoreElements()){
      t = (ASTDataTypeIdentifier) enum.nextElement();
      res+= t.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }

  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    DataTypeIdentifierEnumeration enum = (DataTypeIdentifierEnumeration) getNodes();
    ASTDataTypeIdentifier elem;
    while(enum.hasMoreElements()){
      elem = (ASTDataTypeIdentifier) enum.nextElement();
      elem.setParent(n);
    }
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    DataTypeIdentifierEnumeration enum = (DataTypeIdentifierEnumeration) getNodes();
    ASTDataTypeIdentifier t;
    while(enum.hasMoreElements()){
      t = (ASTDataTypeIdentifier) enum.nextElement();
      t.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);


    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
