package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTDataTypeReference extends GenericNode implements ASTPortTypeReference{
  private ASTDataTypeIdentifier typeId;
  private boolean isArray = false;
  private Node parent = null;

  public ASTDataTypeReference(ASTDataTypeIdentifier type) {
    Assert.require(type);
    typeId = type;
  }
  public void setArrayOfPorts(){
    isArray = true;
  };
  public boolean isArrayOfPorts(){
    return isArray;
  };

  public void setParent(Node n){
    Assert.require(n);
    parent = n;
  }

  public ASTDataTypeIdentifier getTypeId() {
    return(typeId);
  }

  public Node getParent(){
    return parent;
  }

  public String toString(){
    String res = "data ";
    if(typeId != null)
      res+=typeId.toString();
    if(isArray)
      res += "[]";
    return res;
  }
  public String toPrologString(){
    String res = "";
    if(typeId != null)
      res = typeId.toPrologString();
    return res;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(typeId);
    typeId.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }


}
