package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTExternalTypeName extends GenericNode {
  private ASTDesignator typeName;
  private String typeRest = null;
  public ASTExternalTypeName(ASTDesignator des, String r) {
      Assert.require(des);
      typeName = des;
      typeRest = r;
  }

  public ASTDesignator getDesignator() {
  return typeName;
  }

  public String toString(){
   String res = "";

   res += typeName.toString();
   if(typeRest != null)
    res += typeRest;

   return res;
  }


  public String toPrologString(){
    return "";
  }

   public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(typeName);
    typeName.accept(v, data);

    // todo: make typeRest into an AST node, not a string
    /*if(typeRest != null)
      typeRest.accept(v,data);*/

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}