package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTField extends GenericNode {
  private ASTIdentifier fieldId;

  private ASTDataType parent = null;
  private ASTDataTypeIdentifier typeId;
  public ASTField(ASTIdentifier id, ASTDataTypeIdentifier type) {
    Assert.require(id);
    Assert.require(type);

    fieldId = id;
    typeId = type;
  }

  public ASTIdentifier getFieldId() {
    return(fieldId);
  }

  public ASTDataTypeIdentifier getTypeId() {
    return(typeId);
  }

  public String toString(){
    return typeId.toString() +  "  " + fieldId.toString() +";";
  }

  public void setParent(Node n){
    Assert.require(n);
    Assert.require(n instanceof ASTDataType);
    parent = (ASTDataType)n;
  }

  public Node getParent(){
    return parent;
  }
   public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(typeId);
    typeId.accept(v, data);

    Assert.require(fieldId);
    fieldId.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}