package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;


/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTFieldList extends GenericContainerNode {
  private ASTDataType parent =null;
  public ASTFieldList(ASTField f) {
    super();
    addNode(f);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTField);
    container.add(n);
    if(parent != null)
      n.setParent(parent);

  }

  public Enumeration getNodes(){
    return new FieldEnumeration(container);
  }

  public String toString(){
    FieldEnumeration enum = (FieldEnumeration) getNodes();
    String res = "";
    ASTField f;
    while(enum.hasMoreElements()){
      f = (ASTField) enum.nextElement();
      res+= f.toString();
      if(enum.hasMoreElements())
        res+="\n";
    }
    return res;
  }
  protected void setParents(Node n){
    Assert.require(n);
    Assert.require(n instanceof ASTDataType);
    parent = (ASTDataType)n;


    FieldEnumeration enum = (FieldEnumeration) getNodes();
    ASTField elem;
    while(enum.hasMoreElements()){
      elem = (ASTField) enum.nextElement();
      elem.setParent(n);
    }
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    FieldEnumeration enum = (FieldEnumeration) getNodes();
    ASTField elem;
    while(enum.hasMoreElements()){
      elem = (ASTField) enum.nextElement();
      elem.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);



    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
