package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTFloatLiteral extends ASTNumericLiteral implements ASTLiteral{
  Float value = null;

  public ASTFloatLiteral(String val) {
    Assert.require(val);
    setValue(val);
  }

  public ASTFloatLiteral(){
  }

  public void setValue(String val){
    value = new Float(val);
  }
  public String getValue(){
    return value.toString();
  }

  public float getFloatValue(){
    return value.floatValue();
  }
  public String toString(){
    return value.toString();
  }


  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}