package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTGenericTypeIdentifierList extends GenericNode {
  private ASTIdentifierList typeIdents;
  public ASTGenericTypeIdentifierList(ASTIdentifierList l) {
    Assert.require(l);
    typeIdents = l;
  }

  public ASTIdentifierList getTypeIdents() {
    return(typeIdents);
  }

  public String toString(){
    return typeIdents.toString();
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(typeIdents);
    typeIdents.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }
}