package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTIdentifier extends GenericNode {
  private Node parent = null;

  String value = null;
  public ASTIdentifier(String val) {
    Assert.require(val);
    setID(val);
  }

  public void setID(String val){
   Assert.require(val);
    value = new String(val);
  }

  public String getID(){
    return value;
  }

  public String toString(){
    String res = "";
    if(beforeComments != null)
      res += beforeComments.toString();
    res += value;
    if(afterComments != null)
      res += afterComments.toString();

    return res;
  }

  public Node getParent(){
   return parent;
  }

  public void setParent(Node n){
    Assert.require(n);
    parent = n;
  }

  public String toPrologString(){
    return "'" + value + "'";
  }

  public boolean equals(Object o) {
      boolean res = false;

      if (o instanceof ASTIdentifier) {
	  res = getID().equals(((ASTIdentifier)o).getID());
      }
      return(res);
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }



}
