package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTIdentifierList extends GenericContainerNode{

  public ASTIdentifierList() {
    super();
  }

  public ASTIdentifierList(ASTIdentifier id) {
    super();
    addNode(id);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTIdentifier);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new IdentifierEnumeration(container);
  }

  public String toString(){
    IdentifierEnumeration enum = (IdentifierEnumeration) getNodes();
    String res = "";
    ASTIdentifier id;
    while(enum.hasMoreElements()){
      id = (ASTIdentifier) enum.nextElement();
      res+= id.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }



  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    IdentifierEnumeration enum = (IdentifierEnumeration) getNodes();
    ASTIdentifier elem;
    while(enum.hasMoreElements()){
      elem = (ASTIdentifier) enum.nextElement();
      elem.setParent(n);
    }
  }


  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the elements in the identifier list
    IdentifierEnumeration enum = (IdentifierEnumeration) getNodes();
    ASTIdentifier elem;
    while(enum.hasMoreElements()){
      elem = (ASTIdentifier) enum.nextElement();
      elem.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);

    }
    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }



}
