package coco.parser.ast;

import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTIntLiteral extends ASTNumericLiteral {
  Integer value = null;

  public ASTIntLiteral(String val) {
    Assert.require(val);
    setValue(val);
  }

  public ASTIntLiteral(){
  }

  public String getValue(){
    return value.toString();
  }

  public void setValue(String val){
    value = new Integer(val);
  }

  public int getIntValue(){
    return value.intValue();
  }
  public String toString(){
    return value.toString();
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}