package coco.parser.ast;
import coco.utils.*;
import coco.parser.ast.enums.*;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTInterfaceIdentifierList extends ASTIdentifierList {

  public ASTInterfaceIdentifierList() {
    super();
  }
  public ASTInterfaceIdentifierList(ASTInterfaceIdentifier id) {
    super();
    addNode(id);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTInterfaceIdentifier);
    container.add(n);
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the elements in the identifier list
    IdentifierEnumeration enum = (IdentifierEnumeration) getNodes();
    ASTInterfaceIdentifier elem;
    while(enum.hasMoreElements()){
      elem = (ASTInterfaceIdentifier) enum.nextElement();
      elem.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);
    }
    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}