package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTInvocationParameter extends GenericNode {
  private ASTDataTypeIdentifier paramType;
  private ASTIdentifier paramId;


  public ASTInvocationParameter(ASTDataTypeIdentifier type, ASTIdentifier id) {
    Assert.require(type);
    Assert.require(id);
    paramType = type;
    paramId = id;
  }

  public ASTDataTypeIdentifier getParamType() {
    return(paramType);
  }

  public ASTIdentifier getParamId(){
    return(paramId);
  };

  public String toString(){
    return paramType.toString() + " " + paramId.toString();
  }
  public String toPrologString(){
    return "[" +paramType.toPrologString() + ", " + paramId.toPrologString() + "]";
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the subnodes
    Assert.require(paramType);
    paramType.accept(v, data);
    Assert.require(paramId);
    paramId.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }
}
