package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTInvocationParameterList extends GenericContainerNode {

  public ASTInvocationParameterList(ASTInvocationParameter p){
    super();
    addNode(p);
  }
  public void addNode(Node n){
    Assert.require(n instanceof ASTInvocationParameter);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new InvocationParameterEnumeration(container);
  }

  public String toString(){
    InvocationParameterEnumeration enum = (InvocationParameterEnumeration) getNodes();
    String res = "";
    ASTInvocationParameter p;
    while(enum.hasMoreElements()){
      p = (ASTInvocationParameter) enum.nextElement();
      res+= p.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }

  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    InvocationParameterEnumeration enum = (InvocationParameterEnumeration) getNodes();
    ASTInvocationParameter elem;
    while(enum.hasMoreElements()){
      elem = (ASTInvocationParameter) enum.nextElement();
      elem.setParent(n);
    }
  }

  public String toPrologString(){
    InvocationParameterEnumeration enum = (InvocationParameterEnumeration) getNodes();
    String res = "[";
    ASTInvocationParameter p;
    while(enum.hasMoreElements()){
      p = (ASTInvocationParameter) enum.nextElement();
      res+= p.toPrologString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    res +="]";
    return res;
  }


  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the subnodes
    InvocationParameterEnumeration enum = (InvocationParameterEnumeration) getNodes();
    ASTInvocationParameter p;
    while(enum.hasMoreElements()){
      p = (ASTInvocationParameter) enum.nextElement();
      p.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);



    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }


}
