package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTInvocationSignature extends GenericNode {
  private ASTInvocationParameterList invocationParams = null;
  public ASTInvocationSignature(ASTInvocationParameterList epList) {
    invocationParams = epList;
  }


/**
   * setNullASTInvocation makes the invocationParameterList null.
 */

  public void setNullASTInvocationParameterList() {
  invocationParams = null;
  }

  public String toString(){
    String res = "(";
    if(invocationParams !=null)
      res += invocationParams.toString();

    res += ")";

    return res;
  }

  public ASTInvocationParameterList getInvocationParams() {
    return(invocationParams);
  }

  public void setInvocationParams(ASTInvocationParameterList invocationParams) {
  Assert.require(invocationParams);
  this.invocationParams = invocationParams;
  }



  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    if(invocationParams != null)
      invocationParams.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }


}
