package coco.parser.ast;
import coco.utils.*;


/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTInvocationTypeReference extends GenericNode implements ASTPortTypeReference{
  private ASTInvocationSignature signature;
  private boolean isArray = false;

  private Node parent = null;

  public ASTInvocationTypeReference(ASTInvocationSignature sig) {
    Assert.require(sig);
    signature = sig;
  }
  public void setArrayOfPorts(){
    isArray = true;
  };
  public boolean isArrayOfPorts(){
    return isArray;
  };
  public void setParent(Node n){
    Assert.require(n);
    parent = n;
  }

  public Node getParent(){
    return parent;
  }

  public ASTInvocationSignature getSignature() {
    return(signature);
  }

  public String toString(){
    String res = "invocation ";
    if(signature != null)
      res+=signature.toString();
    if(isArray)
      res += "[]";
    return res;
  }
  public String toPrologString(){
    String res = "";
    if(signature != null)
      res = signature.toPrologString();
    return res;
  }


  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    Assert.require(signature);
    signature.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
