package coco.parser.ast;
import coco.utils.*;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTMapping extends GenericNode {

  private ASTConstExpression paramExpr = null;
  private ASTConstExpression valueExpr = null;


  public ASTMapping(ASTConstExpression e1, ASTConstExpression e2) {
    Assert.require(e1);
    Assert.require(e2);
    paramExpr = e1;
    valueExpr = e2;
  }

  public ASTConstExpression getParameterExpression(){
    return paramExpr;
  }
  public ASTConstExpression getValueExpression(){
    return valueExpr;
  }

  public String toString(){
    String res = "(" + paramExpr.toString() + ", " + valueExpr.toString() + ")";
    return res;
  }

 public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    Assert.require(paramExpr);
    paramExpr.accept(v, data);
    Assert.require(valueExpr);
    valueExpr.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }


}