package coco.parser.ast;
import coco.utils.*;
import java.util.*;
import coco.parser.ast.enums.MappingEnumeration;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTMappingLiteral extends GenericContainerNode implements ASTLiteral{
  private String value;
  public ASTMappingLiteral(ASTMapping m) {
    super();
    addNode(m);
  }
  public void addNode(Node n){
    Assert.require(n);
    Assert.require(n instanceof ASTMapping);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new MappingEnumeration(container);
  }
  protected void setParents(Node n){
  }

  public String getValue(){
    return "";
  }
  public void setValue(String val){

  }
  public String toString(){
    MappingEnumeration enum = (MappingEnumeration) getNodes();
    String res = "{";
    ASTMapping elem;
    while(enum.hasMoreElements()){
      elem = (ASTMapping) enum.nextElement();
      res+= elem.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    res += "}";
    return res;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    MappingEnumeration enum = (MappingEnumeration) getNodes();
    ASTMapping elem;
    while(enum.hasMoreElements()){
      elem = (ASTMapping) enum.nextElement();
      elem.accept(v, data);
       if(enum.hasMoreElements())
        v.visitIntraList(this);



    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}