package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public class ASTPortAccess extends GenericNode {
  private ASTDesignator designator;
  ASTConnector parent = null;
  public ASTPortAccess(ASTDesignator des) {
    Assert.require(des);
    designator = des;

  }

  public void setParent(Node p){
    Assert.require(p);
    Assert.require(p instanceof ASTConnector);
    parent = (ASTConnector)p;
  }

  public ASTDesignator getDesignator(){
    return designator;
  }


  public String toString(){
    String res = designator.toString();
    return res;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the subnodes
    Assert.require(designator);
    designator.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }


}
