package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */


public class ASTPortBody extends GenericNode {

  private ASTPort parent = null;
  private ASTPropertyList propList = null;

  public ASTPortBody(ASTPropertyList pl) {
    propList = pl;
  }


  public ASTPropertyList getPropertyList() {
    return propList;
  }

  public void setPropertyList(ASTPropertyList l){
    Assert.require(l);
    propList = l;
  }


  public String toString(){
    String res = "{\n";
   if(propList != null)
      res+= propList.toString();
    res +="\n}";
     return res;
  }
  public void setParent(Node p){
    Assert.require(p);
    parent = (ASTPort)p;
  }

  public Node getParent(){
    return parent;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes

     if(propList != null)
      propList.accept(v, data);
     if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }



}