package coco.parser.ast;
import coco.utils.Assert;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTPortPropertySet extends ASTPropertySet {
  static final String UNIT_TYPE = "port property set";
  public ASTPortPropertySet(ASTIdentifier id, ASTAbstractPropertyList props) {
    super(id, props);
  }
  public String getUnitType(){
      return(UNIT_TYPE);
  }
  public Object accept(AbstractASTVisitor v, Object data){
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit subnodes
    Assert.require(this.ident);
    ident.accept(v, data);
    Assert.require(properties);
    properties.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;

  }

}