package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTPortTypeList extends GenericContainerNode {

  public ASTPortTypeList(ASTPortType p){
    super();
    addNode(p);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTPortType);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new PortTypeEnumeration(container);
  }

  public String toString(){
    PortTypeEnumeration enum = (PortTypeEnumeration) getNodes();
    String res = "";
    ASTPortType p;
    while(enum.hasMoreElements()){
      p = (ASTPortType) enum.nextElement();
      res+= p.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }
  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    PortTypeEnumeration enum = (PortTypeEnumeration) getNodes();
    ASTPortType elem;
    while(enum.hasMoreElements()){
      elem = (ASTPortType) enum.nextElement();
      elem.setParent(n);
    }
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    PortTypeEnumeration enum = (PortTypeEnumeration) getNodes();
    ASTPortType p;
    while(enum.hasMoreElements()){
      p = (ASTPortType) enum.nextElement();
      p.accept(v, data);
      if(enum.hasMoreElements())
        v.visitIntraList(this);



    }
    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }
}