package coco.parser.ast;
import java.util.*;
import coco.parser.ast.enums.*;
import coco.utils.*;



/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public class ASTPortTypeReferenceList extends GenericContainerNode {
  private Node parent = null;
  public ASTPortTypeReferenceList(ASTPortTypeReference r){
    super();
    addNode(r);
  }

  public void addNode(Node n){
    Assert.require(n instanceof ASTPortTypeReference);
    container.add(n);
  }

  public Enumeration getNodes(){
    return new PortTypeReferenceEnumeration(container);
  }

  public String toString(){
    PortTypeReferenceEnumeration enum = (PortTypeReferenceEnumeration) getNodes();
    String res = "";
    ASTPortTypeReference r;
    while(enum.hasMoreElements()){
      r = (ASTPortTypeReference) enum.nextElement();
      res+= r.toString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    return res;
  }

  public String toPrologString(){
    PortTypeReferenceEnumeration enum = (PortTypeReferenceEnumeration) getNodes();
    String res = "[";
    ASTPortTypeReference r;
    while(enum.hasMoreElements()){
      r = (ASTPortTypeReference) enum.nextElement();
      res+= r.toPrologString();
      if(enum.hasMoreElements())
        res+=", ";
    }
    res += "]";
    return res;
  }

  public void setParent(Node n){
    Assert.require(n);
    parent = n;
    this.setParents(n);
  }

  public Node getParent(){
    return parent;
  }
  protected void setParents(Node n){
    Assert.require(n);
// todo: possibly type check needed

    PortTypeReferenceEnumeration enum = (PortTypeReferenceEnumeration) getNodes();
    ASTPortTypeReference elem;
    while(enum.hasMoreElements()){
      elem = (ASTPortTypeReference) enum.nextElement();
      elem.setParent(n);
    }
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the sub nodes
    PortTypeReferenceEnumeration enum = (PortTypeReferenceEnumeration) getNodes();
    ASTPortTypeReference r;
    while(enum.hasMoreElements()){
      r = (ASTPortTypeReference) enum.nextElement();
      r.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);


    }

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
