package coco.parser.ast;
import coco.utils.Assert;
/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTPropertyIdentifier extends GenericNode {
  private ASTDesignator value = null;
  private Node parent = null;
  ASTIdentifier ID = null;

  public ASTPropertyIdentifier(ASTDesignator val) {
    Assert.require(val);
    value = val;
    ID = new ASTIdentifier(value.toString());
  }

  public ASTDesignator getDesignator(){
    return value;
  }


  public void setDesignator(ASTDesignator des){
    Assert.require(des);
    value = des;
    ID = new ASTIdentifier(value.toString());
  }

  /**
   * Returns the name of the property as identifier. Designators are made into identifiers.
   */
  public ASTIdentifier getID(){
    return ID;
  }
  public Node getParent(){
   return parent;
  }

  public void setParent(Node n){
    Assert.require(n);
    parent = n;
  }
  public String toString(){
    return value.toString();
  }
  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    value.accept(v, data);

    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}