package coco.parser.ast;

import java.util.*;

import coco.utils.*;
import coco.parser.ast.enums.*;
/**
 * berschrift:   PECOS Composition Environment 2
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTPropertySetReferenceList extends ASTIdentifierList {

  public ASTPropertySetReferenceList() {
    super();
  }

  public ASTPropertySetReferenceList(ASTPropertySetReference r) {
    super();
    addNode(r);
  }
  public void addNode(Node n){
    Assert.require(n instanceof ASTPropertySetReference);
    container.add(n);
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }
    // visit the elements in the identifier list
    //    PropertySetReferenceEnumeration enum = (PropertySetReferenceEnumeration) getNodes();
    Enumeration enum = getNodes();
    ASTPropertySetReference elem;
    while(enum.hasMoreElements()){
      elem = (ASTPropertySetReference) enum.nextElement();
      elem.accept(v, data);

      if(enum.hasMoreElements())
        v.visitIntraList(this);
    }
    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}
