package coco.parser.ast;
import coco.utils.Assert;
import java.util.Vector;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public class ASTUserTypeIdentifier extends ASTDataTypeIdentifier {
  boolean externallyDefined = false;
  public ASTUserTypeIdentifier(String typeId, boolean extern) {
    super(typeId);
    externallyDefined = extern;
  }
  public ASTUserTypeIdentifier(ASTIdentifier type, boolean extern, Vector dims){
    super(type, dims);
    externallyDefined = extern;
  }


  public boolean isExternType(){
    return externallyDefined;
  }

  public void setExternType(boolean extern){
    externallyDefined = extern;
  }

  public Object accept(AbstractASTVisitor v, Object data) {
    if(v.preVisit()){
      v.visitPre(this);
    }

    // visit the subnodes
    Assert.require(typeId);
    typeId.accept(v, data);
    // todo: take care of the dimension stuff


    if(v.postVisit()){
      v.visitPost(this);
    }
    return null;
  }

}