package coco.parser.ast;
import coco.utils.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author
 * @version 1.0
 */

public abstract class AbstractASTVisitor {

	abstract public boolean preVisit();
	abstract public boolean postVisit();

	abstract public Object visitPre(ASTComponentList node);
	abstract public Object visitIntraList(ASTComponentList node);



	abstract public Object visitPost(ASTComponentList node);




	abstract public Object visitPre(ASTComponent node);
	abstract public Object visitPost(ASTComponent node);





	abstract public Object visitPre(ASTInterfaceIdentifierList node);

	abstract public Object visitIntraList(ASTInterfaceIdentifierList node);
        abstract public Object visitPost(ASTInterfaceIdentifierList node);

	abstract public Object visitPre(ASTInterfaceIdentifier node);
	abstract public Object visitPost(ASTInterfaceIdentifier node);


	abstract public Object visitPre(ASTComponentTypeIdentifier node);
	abstract public Object visitPost(ASTComponentTypeIdentifier node);

	abstract public Object visitPre(ASTRoleIdentifier node);
	abstract public Object visitPost(ASTRoleIdentifier node);



	abstract public Object visitPre(ASTComponentBody node);
	abstract public Object visitPost(ASTComponentBody node);


	abstract public Object visitPre(ASTComponentPropertySet node);
	abstract public Object visitPost(ASTComponentPropertySet node);

	abstract public Object visitPre(ASTConnectorPropertySet node);
	abstract public Object visitPost(ASTConnectorPropertySet node);

        abstract public Object visitPre(ASTPortPropertySet node);
	abstract public Object visitPost(ASTPortPropertySet node);





	abstract public Object visitPre(ASTInterfaceBody node);
	abstract public Object visitPost(ASTInterfaceBody node);


	abstract public Object visitPre(ASTInterface node);
	abstract public Object visitPost(ASTInterface node);

	abstract public Object visitPre(ASTHandler node);
	abstract public Object visitPost(ASTHandler node);




	abstract public Object visitPre(ASTNumericLiteral node);
	abstract public Object visitPost(ASTNumericLiteral node);

	abstract public Object visitPre(ASTInvocationTypeReference node);
	abstract public Object visitPost(ASTInvocationTypeReference node);


	abstract public Object visitPre(ASTField node);
	abstract public Object visitPost(ASTField node);

	abstract public Object visitPre(ASTHandlerTypeReference node);
	abstract public Object visitPost(ASTHandlerTypeReference node);



        abstract public Object visitPre(ASTPortAccess node);
	abstract public Object visitPost(ASTPortAccess node);




	abstract public Object visitPre(ASTPortTypeList node);

	abstract public Object visitIntraList(ASTPortTypeList node);


	abstract public Object visitPost(ASTPortTypeList node);







	abstract public Object visitPre(ASTIdentifierList node);

	abstract public Object visitIntraList(ASTIdentifierList node);


	abstract public Object visitPost(ASTIdentifierList node);


	abstract public Object visitPre(ASTPropertyContainer node);
	abstract public Object visitPost(ASTPropertyContainer node);


	abstract public Object visitPre(ASTPortModifiers node);
	abstract public Object visitPost(ASTPortModifiers node);

	abstract public Object visitPre(ASTIdentifier node);
	abstract public Object visitPost(ASTIdentifier node);

	abstract public Object visitPre(ASTPropertyIdentifier node);
	abstract public Object visitPost(ASTPropertyIdentifier node);

	abstract public Object visitPre(ASTCharLiteral node);
	abstract public Object visitPost(ASTCharLiteral node);


	abstract public Object visitPre(ASTPortTypeReferenceList node);

	abstract public Object visitIntraList(ASTPortTypeReferenceList node);



	abstract public Object visitPost(ASTPortTypeReferenceList node);


	abstract public Object visitPre(ASTInvocationSignature node);
	abstract public Object visitPost(ASTInvocationSignature node);


	abstract public Object visitPre(ASTUserTypeIdentifier node);
	abstract public Object visitPost(ASTUserTypeIdentifier node);

	abstract public Object visitPre(ASTBaseTypeIdentifier node);
	abstract public Object visitPost(ASTBaseTypeIdentifier node);

	abstract public Object visitPre(ASTBaseTypeReference node);
	abstract public Object visitPost(ASTBaseTypeReference node);

	abstract public Object visitPre(ASTInvocationParameterList node);

	abstract public Object visitIntraList(ASTInvocationParameterList node);


	abstract public Object visitPost(ASTInvocationParameterList node);




	abstract public Object visitPre(ASTBoolLiteral node);
	abstract public Object visitPost(ASTBoolLiteral node);



	abstract public Object visitPre(ASTConnector node);
	abstract public Object visitPost(ASTConnector node);

	abstract public Object visitPre(ASTConstExpression node);
	abstract public Object visitPost(ASTConstExpression node);


	abstract public Object visitPre(ASTProperty node);
	abstract public Object visitPost(ASTProperty node);


	abstract public Object visitPre(ASTPortBody node);
	abstract public Object visitPost(ASTPortBody node);




	abstract public Object visitPre(ASTConnectorBody node);
	abstract public Object visitPost(ASTConnectorBody node);


	abstract public Object visitPre(ASTFloatLiteral node);
	abstract public Object visitPost(ASTFloatLiteral node);


	abstract public Object visitPre(ASTPortList node);

	abstract public Object visitIntraList(ASTPortList node);


	abstract public Object visitPost(ASTPortList node);


	abstract public Object visitPre(ASTDesignator node);


	abstract public Object visitIntraList(ASTDesignator node);

	abstract public Object visitPost(ASTDesignator node);



	abstract public Object visitPre(ASTConnectorList node);

	abstract public Object visitIntraList(ASTConnectorList node);



	abstract public Object visitPost(ASTConnectorList node);


	abstract public Object visitPre(ASTPortAccessList node);

	abstract public Object visitIntraList(ASTPortAccessList node);



	abstract public Object visitPost(ASTPortAccessList node);


	abstract public Object visitPre(ASTStringLiteral node);
	abstract public Object visitPost(ASTStringLiteral node);


	abstract public Object visitPre(ASTConstExpressionList node);
	abstract public Object visitIntraList(ASTConstExpressionList node);



	abstract public Object visitPost(ASTConstExpressionList node);


	abstract public Object visitPre(ASTPortTypeReference node);
	abstract public Object visitPost(ASTPortTypeReference node);


	abstract public Object visitPre(ASTInvocationParameter node);
	abstract public Object visitPost(ASTInvocationParameter node);


	abstract public Object visitPre(ASTInstanceList node);
	abstract public Object visitIntraList(ASTInstanceList node);
	abstract public Object visitPost(ASTInstanceList node);

	abstract public Object visitPre(ASTRoleList node);
	abstract public Object visitIntraList(ASTRoleList node);
	abstract public Object visitPost(ASTRoleList node);

	abstract public Object visitPre(ASTRole node);
	abstract public Object visitPost(ASTRole node);



	abstract public Object visitPre(ASTFieldList node);

	abstract public Object visitIntraList(ASTFieldList node);


	abstract public Object visitPost(ASTFieldList node);



	abstract public Object visitPre(ASTInstance node);
	abstract public Object visitPost(ASTInstance node);


	abstract public Object visitPre(ASTData node);
	abstract public Object visitPost(ASTData node);


	abstract public Object visitPre(ASTCompilationUnit node);
	abstract public Object visitPost(ASTCompilationUnit node);


	abstract public Object visitPre(ASTIntLiteral node);
	abstract public Object visitPost(ASTIntLiteral node);




	abstract public Object visitPre(ASTPort node);
	abstract public Object visitPost(ASTPort node);


	abstract public Object visitPre(ASTDataTypeReference node);
	abstract public Object visitPost(ASTDataTypeReference node);



	abstract public Object visitPre(ASTPortType node);
	abstract public Object visitPost(ASTPortType node);



	abstract public Object visitPre(ASTDataTypeList node);

	abstract public Object visitIntraList(ASTDataTypeList node);



	abstract public Object visitPost(ASTDataTypeList node);


	abstract public Object visitPre(ASTPropertyList node);
	abstract public Object visitIntraList(ASTPropertyList node);



	abstract public Object visitPost(ASTPropertyList node);


	abstract public Object visitPre(ASTGenericTypeIdentifierList node);



	abstract public Object visitPost(ASTGenericTypeIdentifierList node);



	abstract public Object visitPre(ASTDataTypeIdentifierList node);
	abstract public Object visitIntraList(ASTDataTypeIdentifierList node);



	abstract public Object visitPost(ASTDataTypeIdentifierList node);


	abstract public Object visitPre(ASTEntititySpec node);
	abstract public Object visitPost(ASTEntititySpec node);



	abstract public Object visitPre(ASTDataType node);
	abstract public Object visitPost(ASTDataType node);


	abstract public Object visitPre(ASTGenericTypeParameter node);
	abstract public Object visitPost(ASTGenericTypeParameter node);

	abstract public Object visitPre(ASTMappingLiteral node);
	abstract public Object visitIntraList(ASTMappingLiteral node);



	abstract public Object visitPost(ASTMappingLiteral node);

	abstract public Object visitPre(ASTMapping node);
	abstract public Object visitPost(ASTMapping node);



	abstract public Object visitPre(ASTExternalTypeName node);
	abstract public Object visitPost(ASTExternalTypeName node);


	abstract public Object visitPre(ASTRoot node);
	abstract public Object visitPost(ASTRoot node);


	abstract public Object visitPre(ASTGenericTypeParameterList node);

	abstract public Object visitIntraList(ASTGenericTypeParameterList node);


	abstract public Object visitPost(ASTGenericTypeParameterList node);

}
