package coco.parser.ast;
import java.util.*;
import coco.parser.ParseException;
import coco.utils.*;
/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

public abstract class GenericContainerNode extends GenericNode implements ASTContainer{
  protected Vector container;
  public GenericContainerNode() {
    container = new Vector(10,3);
  }
  public void addNode(Node n) throws ParseException{
    container.add(n);
  }


  public void removeNode(Node n){
    container.remove(n);
  }

  public void addContainer(GenericContainerNode newNodes) throws ParseException{
    Assert.require(container);
    Assert.require(newNodes);

    Enumeration enum = newNodes.getNodes();
    while(enum.hasMoreElements()){
      Node n = (Node) enum.nextElement();
      addNode(n);
    }

  }


  public Enumeration getNodes(){
    return container.elements();
  }

  void add(GenericContainerNode nodes){
    Assert.require(null);
  }

  void union(GenericContainerNode nodes){
    Assert.require(null);
  }

  public void setParent(Node n){
   // set the parent for each contained node
   setParents(n);
  }
  public Vector getChildren(){
    Assert.require(container);
    return container;
  }

  public int getNumChildren(){
    int res = 0;
    if (container != null) res = container.size();
    return(res);
  }

  public Node getChild(int i){
    Node res = null;
    if ((i > -1) && (i < getNumChildren())) res = (Node)container.elementAt(i);
    return(res);
  }

  /** Sets the parent node for all members of this collection, must be implemented by subclasses
   * @param n the parent node
   *
   */
  protected abstract void setParents(Node n);
}