package coco.parser.ast.enums;
import java.util.*;
import coco.parser.ast.GenericContainerNode;
import coco.parser.ast.ASTInstance;
import coco.utils.*;

/**
 * berschrift:   PECOS Composition Environment
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:  FZI
 * @author T. Genssler, A. Christoph
 * @version 1.0
 */

public class InstanceEnumeration implements Enumeration{
  private Enumeration enum;


  public InstanceEnumeration(Vector v) {
    Assert.require(v);
    enum = v.elements();
  }

  public boolean hasMoreElements(){
    return enum.hasMoreElements();
  }

  public Object nextElement() throws NoSuchElementException{
    // throws a type cast exception, if retval is not a instance
    ASTInstance i = (ASTInstance)enum.nextElement();
    return i;
  }
}
