/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author A.Christoph (FZI)
 * @version 1.0
 */

package coco.tools;

import coco.project.*;

/**
 * This class describes an abstract interface for tools external to the CompEnv framework.
 */
public interface CoCoTool {

    /** 
     * Retrieves the menu entry in the tools menu of the application.
     */
    public String getMenuText();

    /**
     * Retrieves the description used for help purposes.
     */
    public String getDescription();

    /**
     * Retrieves a version string for this tool.
     */
    public String getVersion();

    /**
     * Starts the operation of this tool. 
     * @param project the current project to operate on.
     */
    public void execute(CoCoProject project);
}
