/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author A.Christoph (FZI)
 * @version 1.0
 */

package coco.tools;

import java.util.*;

import coco.config.*;

/**
 * This class implements a service, which can locate all installed tools
 */
public class ToolService {
    
    /**
     * Retrieves an enumeration containing references to CoCoTool objects
     * The list of installed tools is currently contained in the GlobalConfig set of options.
     */
    public static Enumeration getTools() {
	Vector res = new Vector();

	GlobalConfig cfg = GlobalConfig.getInstance();
	Properties props = cfg.getProperties();

	Enumeration keys = props.propertyNames();
	while (keys.hasMoreElements()) {
	    String key = (String)keys.nextElement();

	    // if a property starts with "tools." then 
	    // its value must be the name of a class which implements CoCoTool

	    if (key.startsWith("tools.")) {
		String value = props.getProperty(key);
		
		try {
		    ClassLoader l = ClassLoader.getSystemClassLoader();
		    Class cl = l.loadClass(value);
		    res.add(cl.newInstance());
		} catch (Exception ex) {
		    ex.printStackTrace();
		}
	    }
	}
	
	return(res.elements());
    }
}
