package coco.utils;

import java.io.*;

import javax.swing.JTextArea;
import java.io.PrintStream;
import coco.utils.Assert;
/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */



public class TextAreaOutputStream extends PrintStream {
  private JTextArea target = null;
  private PrintStream orig = null;
  private boolean showOrig = false;

  public TextAreaOutputStream(JTextArea t, PrintStream orig, boolean showOrig) {
    super(new ByteArrayOutputStream());
    Assert.require(t);
    target = t;

    if(showOrig)
      Assert.require(orig);

    this.showOrig = showOrig;
    this.orig = orig;
  }
  public void print(boolean b){
    if(showOrig)
      orig.print(b);
    if(b)
      target.append("true");
    else
      target.append("false");
    target.setCaretPosition(target.getText().length());
  }

  public void println(boolean b){
    if(showOrig)
      orig.println(b);

    if(b)
      target.append("true\n");
    else
      target.append("false\n");
    target.setCaretPosition(target.getText().length());
  }



  public void print(char c){
  if(showOrig)
      orig.print(c);

    char[] tmp = new char[1];
    tmp[0] = c;
    target.append(new String(tmp));
    target.setCaretPosition(target.getText().length());
  }

  public void println(char c){
    if(showOrig)
        orig.println(c);


    char[] tmp = new char[2];
    tmp[0] = c;
    tmp[1] = '\n';
    target.append(new String(tmp));
    target.setCaretPosition(target.getText().length());
  }

  public void print(char[] s){
    if(showOrig)
        orig.print(s);

    target.append(new String(s));
    target.setCaretPosition(target.getText().length());
  }

  public void println(char[] s){
    if(showOrig)
      orig.println(s);

    target.append(new String(s)+"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(double d){
    if(showOrig)
      orig.print(d);

    target.append(Double.toString(d));
    target.setCaretPosition(target.getText().length());
  }
  public void println(double d){
    if(showOrig)
      orig.println(d);

    target.append(Double.toString(d)+"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(float f){
    if(showOrig)
      orig.print(f);

    target.append(Float.toString(f));
    target.setCaretPosition(target.getText().length());
  }
  public void println(float f){
    if(showOrig)
      orig.println(f);

    target.append(Float.toString(f)+"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(int i){
    if(showOrig)
      orig.print(i);

    target.append(Integer.toString(i));
    target.setCaretPosition(target.getText().length());
  }
  public void println(int i){
    if(showOrig)
      orig.println(i);

    target.append(Integer.toString(i)+"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(long l){
    if(showOrig)
      orig.print(l);

    target.append(Long.toString(l));
    target.setCaretPosition(target.getText().length());
  }
  public void println(long l){
    if(showOrig)
      orig.println(l);

    target.append(Long.toString(l) +"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(Object o){
    if(showOrig)
      orig.print(o);

    target.append(o.toString());
    target.setCaretPosition(target.getText().length());
  }
  public void println(Object o){
    if(showOrig)
      orig.println(o);

    target.append(o.toString()+"\n");
    target.setCaretPosition(target.getText().length());
  }

  public void print(String s){
    if(showOrig)
      orig.print(s);

    target.append(s);
    target.setCaretPosition(target.getText().length());
  }

  public void println(String s){
    if(showOrig)
      orig.println(s);

    target.append(s + "\n");
    target.setCaretPosition(target.getText().length());
  }

  public void println(){
    if(showOrig)
      orig.println();

    target.append(new String("\n"));
    target.setCaretPosition(target.getText().length());
  }

}
